package COM.objectspace.jgl;

import java.io.Serializable;

public final class ArrayIterator implements RandomAccessIterator, Serializable {
   Array myArray;
   int myIndex;

   public ArrayIterator() {
   }

   public ArrayIterator(ArrayIterator var1) {
      this.myArray = var1.myArray;
      this.myIndex = var1.myIndex;
   }

   public ArrayIterator(Array var1, int var2) {
      this.myArray = var1;
      this.myIndex = var2;
   }

   public Object clone() {
      return new ArrayIterator(this);
   }

   public boolean equals(Object var1) {
      if (var1 instanceof ArrayIterator) {
         ArrayIterator var2 = (ArrayIterator)var1;
         if (var2.myIndex == this.myIndex && (var2.myArray == this.myArray || false)) {
            return true;
         }
      }

      return false;
   }

   public boolean equals(ArrayIterator var1) {
      return var1.myIndex == this.myIndex && var1.myArray == this.myArray;
   }

   public boolean less(RandomAccessIterator var1) {
      return this.myIndex < ((ArrayIterator)var1).myIndex;
   }

   public Object get(int var1) {
      return this.myArray.at(this.myIndex + var1);
   }

   public void put(int var1, Object var2) {
      this.myArray.put(this.myIndex + var1, var2);
   }

   public boolean atBegin() {
      return this.myIndex == 0;
   }

   public boolean atEnd() {
      return this.myIndex == this.myArray.size();
   }

   public boolean hasMoreElements() {
      return this.myIndex < this.myArray.size();
   }

   public void advance() {
      ++this.myIndex;
   }

   public void advance(int var1) {
      this.myIndex += var1;
   }

   public void retreat() {
      --this.myIndex;
   }

   public void retreat(int var1) {
      this.myIndex -= var1;
   }

   public Object nextElement() {
      return this.myArray.at(this.myIndex++);
   }

   public Object get() {
      return this.myArray.at(this.myIndex);
   }

   public void put(Object var1) {
      this.myArray.put(this.myIndex, var1);
   }

   public int distance(ForwardIterator var1) {
      return ((ArrayIterator)var1).myIndex - this.myIndex;
   }

   public int index() {
      return this.myIndex;
   }

   public Container getContainer() {
      return this.myArray;
   }
}
