package COM.objectspace.jgl;

import java.io.Serializable;

public final class BooleanIterator implements RandomAccessIterator, Serializable {
   BooleanArray myBooleanArray;
   boolean[] myArray;
   int myIndex;

   public static BooleanIterator begin(boolean[] var0) {
      return new BooleanIterator(var0, 0, new BooleanArray(var0));
   }

   public static BooleanIterator begin(boolean[] var0, BooleanArray var1) {
      return new BooleanIterator(var0, 0, var1);
   }

   public static BooleanIterator end(boolean[] var0) {
      return new BooleanIterator(var0, var0.length, new BooleanArray(var0));
   }

   public static BooleanIterator end(boolean[] var0, BooleanArray var1) {
      return new BooleanIterator(var0, var0.length, var1);
   }

   public BooleanIterator() {
   }

   public BooleanIterator(boolean[] var1, int var2) {
      this.myBooleanArray = new BooleanArray(var1);
      this.myArray = var1;
      this.myIndex = var2;
   }

   public BooleanIterator(boolean[] var1, int var2, BooleanArray var3) {
      this.myBooleanArray = var3;
      this.myArray = var1;
      this.myIndex = var2;
   }

   public BooleanIterator(BooleanIterator var1) {
      this.myBooleanArray = var1.myBooleanArray;
      this.myArray = var1.myArray;
      this.myIndex = var1.myIndex;
   }

   public Object clone() {
      return new BooleanIterator(this);
   }

   public int index() {
      return this.myIndex;
   }

   public boolean equals(Object var1) {
      if (var1 instanceof BooleanIterator) {
         BooleanIterator var2 = (BooleanIterator)var1;
         if (var2.myIndex == this.myIndex && (var2.myArray == this.myArray || false)) {
            return true;
         }
      }

      return false;
   }

   public boolean equals(BooleanIterator var1) {
      return var1.myIndex == this.myIndex && var1.myArray == this.myArray;
   }

   public boolean less(RandomAccessIterator var1) {
      return this.myIndex < ((BooleanIterator)var1).myIndex;
   }

   public Object get(int var1) {
      return this.myArray[this.myIndex + var1] ? Boolean.TRUE : Boolean.FALSE;
   }

   public void put(int var1, Object var2) {
      this.myArray[this.myIndex + var1] = (Boolean)var2;
   }

   public boolean atBegin() {
      return this.myIndex == 0;
   }

   public boolean atEnd() {
      return this.myIndex == this.myArray.length;
   }

   public boolean hasMoreElements() {
      return this.myIndex < this.myArray.length;
   }

   public void advance() {
      ++this.myIndex;
   }

   public void advance(int var1) {
      this.myIndex += var1;
   }

   public void retreat() {
      --this.myIndex;
   }

   public void retreat(int var1) {
      this.myIndex -= var1;
   }

   public Object nextElement() {
      return new Boolean(this.myArray[this.myIndex++]);
   }

   public Object get() {
      return new Boolean(this.myArray[this.myIndex]);
   }

   public void put(Object var1) {
      this.myArray[this.myIndex] = (Boolean)var1;
   }

   public int distance(ForwardIterator var1) {
      return ((BooleanIterator)var1).myIndex - this.myIndex;
   }

   public Container getContainer() {
      return this.myBooleanArray;
   }
}
