package COM.objectspace.jgl;

import java.io.Serializable;

public final class ByteIterator implements RandomAccessIterator, Serializable {
   ByteArray myByteArray;
   byte[] myArray;
   int myIndex;

   public static ByteIterator begin(byte[] var0) {
      return new ByteIterator(var0, 0, new ByteArray(var0));
   }

   public static ByteIterator begin(byte[] var0, ByteArray var1) {
      return new ByteIterator(var0, 0, var1);
   }

   public static ByteIterator end(byte[] var0) {
      return new ByteIterator(var0, var0.length, new ByteArray(var0));
   }

   public static ByteIterator end(byte[] var0, ByteArray var1) {
      return new ByteIterator(var0, var0.length, var1);
   }

   public ByteIterator() {
   }

   public ByteIterator(ByteIterator var1) {
      this.myByteArray = var1.myByteArray;
      this.myArray = var1.myArray;
      this.myIndex = var1.myIndex;
   }

   public ByteIterator(byte[] var1) {
      this(var1, 0, new ByteArray(var1));
   }

   public ByteIterator(byte[] var1, ByteArray var2) {
      this(var1, 0, var2);
   }

   public ByteIterator(byte[] var1, int var2) {
      this(var1, var2, new ByteArray(var1));
   }

   public ByteIterator(byte[] var1, int var2, ByteArray var3) {
      this.myByteArray = var3;
      this.myArray = var1;
      this.myIndex = var2;
   }

   public Object clone() {
      return new ByteIterator(this);
   }

   public int index() {
      return this.myIndex;
   }

   public boolean equals(Object var1) {
      if (var1 instanceof ByteIterator) {
         ByteIterator var2 = (ByteIterator)var1;
         if (var2.myIndex == this.myIndex && (var2.myArray == this.myArray || false)) {
            return true;
         }
      }

      return false;
   }

   public boolean equals(ByteIterator var1) {
      return var1.myIndex == this.myIndex && var1.myArray == this.myArray;
   }

   public boolean less(RandomAccessIterator var1) {
      return this.myIndex < ((ByteIterator)var1).myIndex;
   }

   public Object get(int var1) {
      return new Integer(this.myArray[this.myIndex + var1]);
   }

   public void put(int var1, Object var2) {
      this.myArray[this.myIndex + var1] = (byte)(Integer)var2;
   }

   public boolean atBegin() {
      return this.myIndex == 0;
   }

   public boolean atEnd() {
      return this.myIndex == this.myArray.length;
   }

   public boolean hasMoreElements() {
      return this.myIndex < this.myArray.length;
   }

   public void advance() {
      ++this.myIndex;
   }

   public void advance(int var1) {
      this.myIndex += var1;
   }

   public void retreat() {
      --this.myIndex;
   }

   public void retreat(int var1) {
      this.myIndex -= var1;
   }

   public Object nextElement() {
      return new Integer(this.myArray[this.myIndex++]);
   }

   public Object get() {
      return new Integer(this.myArray[this.myIndex]);
   }

   public void put(Object var1) {
      this.myArray[this.myIndex] = (byte)(Integer)var1;
   }

   public int distance(ForwardIterator var1) {
      return ((ByteIterator)var1).myIndex - this.myIndex;
   }

   public Container getContainer() {
      return this.myByteArray;
   }
}
