package COM.objectspace.jgl;

import java.io.Serializable;

public final class CharIterator implements RandomAccessIterator, Serializable {
   CharArray myCharArray;
   char[] myArray;
   int myIndex;

   public static CharIterator begin(char[] var0) {
      return new CharIterator(var0, 0, new CharArray(var0));
   }

   public static CharIterator begin(char[] var0, CharArray var1) {
      return new CharIterator(var0, 0, var1);
   }

   public static CharIterator end(char[] var0) {
      return new CharIterator(var0, var0.length, new CharArray(var0));
   }

   public static CharIterator end(char[] var0, CharArray var1) {
      return new CharIterator(var0, var0.length, var1);
   }

   public CharIterator() {
   }

   public CharIterator(CharIterator var1) {
      this.myCharArray = var1.myCharArray;
      this.myArray = var1.myArray;
      this.myIndex = var1.myIndex;
   }

   public CharIterator(char[] var1, int var2) {
      this(var1, var2, new CharArray(var1));
   }

   public CharIterator(char[] var1, int var2, CharArray var3) {
      this.myCharArray = var3;
      this.myArray = var1;
      this.myIndex = var2;
   }

   public Object clone() {
      return new CharIterator(this);
   }

   public int index() {
      return this.myIndex;
   }

   public boolean equals(Object var1) {
      if (var1 instanceof CharIterator) {
         CharIterator var2 = (CharIterator)var1;
         if (var2.myIndex == this.myIndex && (var2.myArray == this.myArray || false)) {
            return true;
         }
      }

      return false;
   }

   public boolean equals(CharIterator var1) {
      return var1.myIndex == this.myIndex && var1.myArray == this.myArray;
   }

   public boolean less(RandomAccessIterator var1) {
      return this.myIndex < ((CharIterator)var1).myIndex;
   }

   public Object get(int var1) {
      return new Character(this.myArray[this.myIndex + var1]);
   }

   public void put(int var1, Object var2) {
      this.myArray[this.myIndex + var1] = (Character)var2;
   }

   public boolean atBegin() {
      return this.myIndex == 0;
   }

   public boolean atEnd() {
      return this.myIndex == this.myArray.length;
   }

   public boolean hasMoreElements() {
      return this.myIndex < this.myArray.length;
   }

   public void advance() {
      ++this.myIndex;
   }

   public void advance(int var1) {
      this.myIndex += var1;
   }

   public void retreat() {
      --this.myIndex;
   }

   public void retreat(int var1) {
      this.myIndex -= var1;
   }

   public Object nextElement() {
      return new Character(this.myArray[this.myIndex++]);
   }

   public Object get() {
      return new Character(this.myArray[this.myIndex]);
   }

   public void put(Object var1) {
      this.myArray[this.myIndex] = (Character)var1;
   }

   public int distance(ForwardIterator var1) {
      return ((CharIterator)var1).myIndex - this.myIndex;
   }

   public Container getContainer() {
      return this.myCharArray;
   }
}
