package COM.objectspace.jgl;

public final class Copying {
   private Copying() {
   }

   public static OutputIterator copy(InputIterator var0, InputIterator var1, OutputIterator var2) {
      InputIterator var3 = (InputIterator)var0.clone();
      OutputIterator var4 = (OutputIterator)var2.clone();

      while(!var3.equals(var1)) {
         var4.put(var3.nextElement());
         var4.advance();
      }

      return var4;
   }

   public static OutputIterator copy(Container var0, OutputIterator var1) {
      return copy(var0.start(), var0.finish(), var1);
   }

   public static void copy(Container var0, Container var1) {
      copy(var0.start(), var0.finish(), new InsertIterator(var1));
   }

   public static OutputIterator copyBackward(BidirectionalIterator var0, BidirectionalIterator var1, BidirectionalIterator var2) {
      BidirectionalIterator var3 = (BidirectionalIterator)var1.clone();
      BidirectionalIterator var4 = (BidirectionalIterator)var2.clone();

      while(!var0.equals(var3)) {
         var4.retreat();
         var3.retreat();
         var4.put(var3.get());
      }

      return var4;
   }
}
