package COM.objectspace.jgl;

public final class Counting {
   private Counting() {
   }

   public static int count(InputIterator var0, InputIterator var1, Object var2) {
      InputIterator var3 = (InputIterator)var0.clone();
      int var4 = 0;

      while(!var3.equals(var1)) {
         if (var3.nextElement().equals(var2)) {
            ++var4;
         }
      }

      return var4;
   }

   public static int count(Container var0, Object var1) {
      return count(var0.start(), var0.finish(), var1);
   }

   public static int countIf(InputIterator var0, InputIterator var1, UnaryPredicate var2) {
      InputIterator var3 = (InputIterator)var0.clone();
      int var4 = 0;

      while(!var3.equals(var1)) {
         if (var2.execute(var3.nextElement())) {
            ++var4;
         }
      }

      return var4;
   }

   public static int countIf(Container var0, UnaryPredicate var1) {
      return countIf(var0.start(), var0.finish(), var1);
   }

   public static Number accumulate(InputIterator var0, InputIterator var1, Number var2) {
      return accumulate(var0, var1, var2, new PlusNumber(var2.getClass()));
   }

   public static Number accumulate(Container var0, Number var1) {
      return accumulate(var0.start(), var0.finish(), var1, new PlusNumber(var1.getClass()));
   }

   public static Number accumulate(InputIterator var0, InputIterator var1, Number var2, BinaryFunction var3) {
      for(InputIterator var4 = (InputIterator)var0.clone(); !var4.equals(var1); var2 = (Number)var3.execute(var2, var4.nextElement())) {
      }

      return var2;
   }

   public static Number accumulate(Container var0, Number var1, BinaryFunction var2) {
      return accumulate(var0.start(), var0.finish(), var1, var2);
   }

   public static OutputIterator adjacentDifference(InputIterator var0, InputIterator var1, OutputIterator var2) {
      return adjacentDifference(var0, var1, var2, new MinusNumber());
   }

   public static OutputIterator adjacentDifference(Container var0, OutputIterator var1) {
      return adjacentDifference(var0.start(), var0.finish(), var1, new MinusNumber());
   }

   public static OutputIterator adjacentDifference(Container var0, Container var1) {
      return adjacentDifference(var0.start(), var0.finish(), new InsertIterator(var1), new MinusNumber());
   }

   public static OutputIterator adjacentDifference(InputIterator var0, InputIterator var1, OutputIterator var2, BinaryFunction var3) {
      OutputIterator var4 = (OutputIterator)var2.clone();
      if (var0.equals(var1)) {
         return var4;
      } else {
         InputIterator var5 = (InputIterator)var0.clone();
         var4.put(var5.get());
         var4.advance();

         Object var7;
         for(Object var6 = var5.nextElement(); !var5.equals(var1); var6 = var7) {
            var7 = var5.nextElement();
            var4.put(var3.execute(var7, var6));
            var4.advance();
         }

         return var4;
      }
   }

   public static OutputIterator adjacentDifference(Container var0, OutputIterator var1, BinaryFunction var2) {
      return adjacentDifference(var0.start(), var0.finish(), var1, var2);
   }

   public static OutputIterator adjacentDifference(Container var0, Container var1, BinaryFunction var2) {
      return adjacentDifference(var0.start(), var0.finish(), new InsertIterator(var1), var2);
   }
}
