package COM.objectspace.jgl;

import java.util.Enumeration;

public class DList implements Sequence {
   DListNode myNode;
   int myLength;

   public DList() {
      this.myNode = new DListNode(this);
      this.myNode.next = this.myNode;
      this.myNode.previous = this.myNode;
   }

   public DList(int var1) {
      this();
      DListNode var2 = this.myNode.next;
      int var3 = var1;
      if (var1 < 0) {
         throw new IllegalArgumentException("Attempt to specify a insert a negative number of objects");
      } else {
         while(var3-- > 0) {
            this.insert((DListNode)var2, (Object)null);
         }

      }
   }

   public DList(int var1, Object var2) {
      this();
      DListNode var3 = this.myNode.next;
      int var4 = var1;
      if (var1 < 0) {
         throw new IllegalArgumentException("Attempt to specify a insert a negative number of objects");
      } else {
         while(var4-- > 0) {
            this.insert(var3, var2);
         }

      }
   }

   public DList(DList var1) {
      this();
      synchronized(var1){}

      try {
         DListNode var4 = this.myNode.next;
         DListNode var5 = var1.myNode.next;

         for(DListNode var6 = var1.myNode; var5 != var6; var5 = var5.next) {
            this.insert(var4, var5.object);
         }
      } catch (Throwable var8) {
         throw var8;
      }

   }

   public synchronized Object clone() {
      return new DList(this);
   }

   public boolean equals(Object var1) {
      return var1 instanceof DList && this.equals((DList)var1);
   }

   public synchronized boolean equals(DList var1) {
      synchronized(var1){}

      boolean var2;
      try {
         var2 = this.size() == var1.size() && Comparing.equal(this.start(), this.finish(), var1.start());
      } catch (Throwable var8) {
         throw var8;
      }

      return var2;
   }

   public synchronized int hashCode() {
      return Hashing.orderedHash(this.start(), this.finish());
   }

   public synchronized String toString() {
      return "DList" + Printing.toString(this.start(), this.finish());
   }

   public synchronized void copy(DList var1) {
      if (this != var1) {
         synchronized(var1){}

         try {
            DListNode var4 = this.myNode.next;
            DListNode var5 = this.myNode;
            DListNode var6 = var1.myNode.next;

            DListNode var7;
            for(var7 = var1.myNode; var4 != var5 && var6 != var7; var6 = var6.next) {
               var4.object = var6.object;
               var4 = var4.next;
            }

            if (var6 == var7) {
               this.remove(var4, var5);
            } else {
               for(DListNode var8 = var6; var8 != var7; var8 = var8.next) {
                  this.insert(var5, var8.object);
               }
            }
         } catch (Throwable var10) {
            throw var10;
         }

      }
   }

   public boolean isEmpty() {
      return this.myLength == 0;
   }

   public int size() {
      return this.myLength;
   }

   public int maxSize() {
      return Integer.MAX_VALUE;
   }

   // $FF: renamed from: at (int) java.lang.Object
   public synchronized Object method_0(int var1) {
      if (var1 >= 0 && var1 < this.myLength) {
         DListNode var2;
         for(var2 = this.myNode.next; var1-- > 0; var2 = var2.next) {
         }

         return var2.object;
      } else {
         throw new IndexOutOfBoundsException("Attempt to access index " + var1 + " when valid range is 0.." + (this.myLength - 1));
      }
   }

   public synchronized void put(int var1, Object var2) {
      if (var1 >= 0 && var1 < this.myLength) {
         DListNode var3;
         for(var3 = this.myNode.next; var1-- > 0; var3 = var3.next) {
         }

         var3.object = var2;
      } else {
         throw new IndexOutOfBoundsException("Attempt to access index " + var1 + " when valid range is 0.." + (this.myLength - 1));
      }
   }

   public synchronized DListIterator insert(DListIterator var1, Object var2) {
      return new DListIterator(this, this.insert(var1.myNode, var2));
   }

   public synchronized void insert(int var1, Object var2) {
      if (var1 > this.myLength) {
         throw new IndexOutOfBoundsException("Attempt to insert at index " + var1 + " when valid range is 0.." + this.myLength);
      } else {
         this.insert(this.nodeAt(var1), var2);
      }
   }

   public synchronized void insert(DListIterator var1, int var2, Object var3) {
      DListNode var4 = var1.myNode;
      int var5 = var2;
      if (var2 < 0) {
         throw new IllegalArgumentException("Attempt to specify a insert a negative number of objects");
      } else {
         while(var5-- > 0) {
            this.insert(var4, var3);
         }

      }
   }

   public synchronized void insert(int var1, int var2, Object var3) {
      if (var1 > this.myLength) {
         throw new IndexOutOfBoundsException("Attempt to insert at index " + var1 + " when valid range is 0.." + this.myLength);
      } else {
         DListNode var4 = this.nodeAt(var1);
         int var5 = var2;
         if (var2 < 0) {
            throw new IllegalArgumentException("Attempt to specify a insert a negative number of objects");
         } else {
            while(var5-- > 0) {
               this.insert(var4, var3);
            }

         }
      }
   }

   public synchronized void insert(DListIterator var1, InputIterator var2, InputIterator var3) {
      InputIterator var4 = (InputIterator)var2.clone();

      while(!var4.equals(var3)) {
         this.insert(var1.myNode, var4.nextElement());
      }

   }

   public synchronized Object back() {
      if (this.myLength == 0) {
         throw new InvalidOperationException("DList is empty");
      } else {
         return this.myNode.previous.object;
      }
   }

   public synchronized Object front() {
      if (this.myLength == 0) {
         throw new InvalidOperationException("DList is empty");
      } else {
         return this.myNode.next.object;
      }
   }

   public synchronized void clear() {
      this.myNode.next = this.myNode;
      this.myNode.previous = this.myNode;
      this.myLength = 0;
   }

   public synchronized int remove(int var1, int var2) {
      if (var2 < var1) {
         return 0;
      } else {
         this.checkRange(var1, var2);
         return this.remove(this.nodeAt(var1), this.nodeAt(var2 + 1));
      }
   }

   public synchronized int remove(Enumeration var1, Enumeration var2) {
      if (var1 instanceof DListIterator && var2 instanceof DListIterator) {
         if (((DListIterator)var1).myDList == this && ((DListIterator)var2).myDList == this) {
            DListIterator var3 = (DListIterator)var1;
            DListIterator var4 = (DListIterator)var2;
            return this.remove(var3.myNode, var4.myNode);
         } else {
            throw new IllegalArgumentException("Enumeration not for this DList");
         }
      } else {
         throw new IllegalArgumentException("Enumeration not a DListIterator");
      }
   }

   public synchronized Object remove(int var1) {
      if (var1 >= 0 && var1 < this.myLength) {
         return this.remove(this.nodeAt(var1));
      } else {
         throw new IndexOutOfBoundsException("Attempt to access index " + var1 + " when valid range is 0.." + (this.myLength - 1));
      }
   }

   public synchronized Object remove(Enumeration var1) {
      if (!(var1 instanceof DListIterator)) {
         throw new IllegalArgumentException("Enumeration not a DListIterator");
      } else if (((DListIterator)var1).myDList != this) {
         throw new IllegalArgumentException("Enumeration not for this DList");
      } else {
         DListIterator var2 = (DListIterator)var1;
         Object var3 = var2.myNode.object;
         this.remove(((DListIterator)var1).myNode);
         return var3;
      }
   }

   public synchronized void splice(int var1, DList var2) {
      if (var1 > this.myLength) {
         throw new IndexOutOfBoundsException("Attempt to insert at index " + var1 + " when valid range is 0.." + this.myLength);
      } else {
         this.splice(this.nodeAt(var1), var2);
      }
   }

   public synchronized void splice(DListIterator var1, DList var2) {
      this.splice(var1.myNode, var2);
   }

   public synchronized void splice(DListIterator var1, DList var2, DListIterator var3) {
      this.splice(var1.myNode, var2, var3.myNode);
   }

   public synchronized void splice(int var1, DList var2, int var3) {
      if (var1 > this.myLength) {
         throw new IndexOutOfBoundsException("Attempt to insert at index " + var1 + " when valid range is 0.." + this.myLength);
      } else if (var3 >= 0 && var3 < var2.myLength) {
         this.splice(this.nodeAt(var1), var2, var2.nodeAt(var3));
      } else {
         throw new IndexOutOfBoundsException("Attempt to access index " + var3 + " when valid range is 0.." + (var2.myLength - 1));
      }
   }

   public synchronized void splice(DListIterator var1, DList var2, DListIterator var3, DListIterator var4) {
      synchronized(var2){}

      try {
         if (var3.myNode != var4.myNode) {
            if (var2 != this) {
               int var10 = var3.distance(var4);
               var2.myLength -= var10;
               this.myLength += var10;
            } else {
               for(DListNode var7 = var3.myNode.next; var7 != var4.myNode; var7 = var7.next) {
                  if (var1.myNode == var7) {
                     throw new InvalidOperationException("Tried to splice into an overlapping area.");
                  }
               }
            }

            this.transfer(var1.myNode, var3.myNode, var4.myNode);
         }
      } catch (Throwable var9) {
         throw var9;
      }

   }

   public synchronized void splice(int var1, DList var2, int var3, int var4) {
      if (var1 > this.myLength) {
         throw new IndexOutOfBoundsException("Attempt to insert at index " + var1 + " when valid range is 0.." + this.myLength);
      } else if (var3 >= 0 && var3 < var2.myLength) {
         if (var4 >= 0 && var4 < var2.myLength) {
            this.splice(this.iteratorAt(var1), var2, var2.iteratorAt(var3), var2.iteratorAt(var4 + 1));
         } else {
            throw new IndexOutOfBoundsException("Attempt to access index " + var4 + " when valid range is 0.." + (var2.myLength - 1));
         }
      } else {
         throw new IndexOutOfBoundsException("Attempt to access index " + var3 + " when valid range is 0.." + (var2.myLength - 1));
      }
   }

   public synchronized void unique() {
      if (this.myLength != 0) {
         DListNode var1 = this.myNode.next;
         DListNode var2 = this.myNode;

         for(DListNode var3 = var1.next; var3 != var2; var3 = var1.next) {
            if (var1.object.equals(var3.object)) {
               var3.previous.next = var3.next;
               var3.next.previous = var3.previous;
               --this.myLength;
            } else {
               var1 = var3;
            }
         }

      }
   }

   public synchronized Object popBack() {
      if (this.myLength == 0) {
         throw new InvalidOperationException("DList is empty");
      } else {
         DListNode var1 = this.myNode.previous;
         var1.previous.next = var1.next;
         var1.next.previous = var1.previous;
         --this.myLength;
         return var1.object;
      }
   }

   public synchronized void pushFront(Object var1) {
      this.insert(this.myNode.next, var1);
   }

   public synchronized Object popFront() {
      if (this.myLength == 0) {
         throw new InvalidOperationException("DList is empty");
      } else {
         DListNode var1 = this.myNode.next;
         var1.previous.next = var1.next;
         var1.next.previous = var1.previous;
         --this.myLength;
         return var1.object;
      }
   }

   public synchronized Object add(Object var1) {
      this.insert(this.myNode, var1);
      return null;
   }

   public synchronized void pushBack(Object var1) {
      this.insert(this.myNode, var1);
   }

   public synchronized void swap(DList var1) {
      synchronized(var1){}

      try {
         DListNode var4 = this.myNode;
         int var5 = this.myLength;
         this.myNode = var1.myNode;
         this.myLength = var1.myLength;
         var1.myNode = var4;
         var1.myLength = var5;
      } catch (Throwable var7) {
         throw var7;
      }

   }

   public synchronized int remove(Object var1) {
      return this.remove(this.myNode.next, this.myNode, var1, this.myLength);
   }

   public synchronized int remove(Object var1, int var2) {
      return this.remove(this.myNode.next, this.myNode, var1, var2);
   }

   public synchronized int remove(Enumeration var1, Enumeration var2, Object var3) {
      if (var1 instanceof DListIterator && var2 instanceof DListIterator) {
         if (((DListIterator)var1).myDList == this && ((DListIterator)var2).myDList == this) {
            DListIterator var4 = (DListIterator)var1;
            DListIterator var5 = (DListIterator)var2;
            return this.remove(var4.myNode, var5.myNode, var3, this.myLength);
         } else {
            throw new IllegalArgumentException("Enumeration not for this DList");
         }
      } else {
         throw new IllegalArgumentException("Enumeration not a DListIterator");
      }
   }

   public synchronized int remove(int var1, int var2, Object var3) {
      if (var2 < var1) {
         return 0;
      } else {
         this.checkRange(var1, var2);
         return this.remove(this.nodeAt(var1), this.nodeAt(var2 + 1), var3, this.myLength);
      }
   }

   public synchronized DListIterator begin() {
      return new DListIterator(this, this.myNode.next);
   }

   public ForwardIterator start() {
      return this.begin();
   }

   public synchronized DListIterator end() {
      return new DListIterator(this, this.myNode);
   }

   public ForwardIterator finish() {
      return this.end();
   }

   public synchronized Enumeration elements() {
      return new DListIterator(this, this.myNode.next);
   }

   public synchronized int replace(Object var1, Object var2) {
      return Replacing.replace(this.start(), this.finish(), var1, var2);
   }

   public synchronized int replace(DListIterator var1, DListIterator var2, Object var3, Object var4) {
      return Replacing.replace(var1, var2, var3, var4);
   }

   public synchronized int replace(int var1, int var2, Object var3, Object var4) {
      if (var2 < var1) {
         return 0;
      } else {
         this.checkRange(var1, var2);
         return Replacing.replace(this.iteratorAt(var1), this.iteratorAt(var2 + 1), var3, var4);
      }
   }

   public synchronized int count(Object var1) {
      return Counting.count(this.start(), this.finish(), var1);
   }

   public synchronized int count(DListIterator var1, DListIterator var2, Object var3) {
      return Counting.count(var1, var2, var3);
   }

   public synchronized int count(int var1, int var2, Object var3) {
      if (var2 < var1) {
         return 0;
      } else {
         this.checkRange(var1, var2);
         return Counting.count(this.iteratorAt(var1), this.iteratorAt(var2 + 1), var3);
      }
   }

   public synchronized DListIterator find(Object var1) {
      return (DListIterator)Finding.find(this.start(), this.finish(), var1);
   }

   public synchronized int indexOf(Object var1) {
      DListIterator var2 = (DListIterator)Finding.find(this.start(), this.finish(), var1);
      return var2.myNode == this.myNode ? -1 : var2.index();
   }

   public synchronized DListIterator find(DListIterator var1, DListIterator var2, Object var3) {
      return (DListIterator)Finding.find(var1, var2, var3);
   }

   public synchronized int indexOf(int var1, int var2, Object var3) {
      if (var2 < var1) {
         return 0;
      } else {
         this.checkRange(var1, var2);
         DListIterator var4 = this.iteratorAt(var2 + 1);
         DListIterator var5 = this.find(this.iteratorAt(var1), var4, var3);
         return var5.myNode == var4.myNode ? -1 : var5.index();
      }
   }

   public synchronized boolean contains(Object var1) {
      DListIterator var2 = this.find(var1);
      DListIterator var3 = this.end();
      return var2.myNode != var3.myNode && true;
   }

   public synchronized void reverse() {
      if (this.myLength >= 2) {
         DListNode var1 = this.myNode.next.next;

         while(var1 != this.myNode) {
            DListNode var2 = var1;
            var1 = var1.next;
            this.transfer(this.myNode.next, var2, var1);
         }

      }
   }

   private void insert(DListNode var1, int var2, Object var3) {
      if (var2 < 0) {
         throw new IllegalArgumentException("Attempt to specify a insert a negative number of objects");
      } else {
         while(var2-- > 0) {
            this.insert(var1, var3);
         }

      }
   }

   private void splice(DListNode var1, DList var2) {
      synchronized(var2){}

      try {
         if (var2.myLength > 0) {
            this.transfer(var1, var2.myNode.next, var2.myNode);
            this.myLength += var2.myLength;
            var2.myLength = 0;
         }
      } catch (Throwable var5) {
         throw var5;
      }

   }

   private void splice(DListNode var1, DList var2, DListNode var3) {
      synchronized(var2){}

      try {
         if (var1 != var3 && var1 != var3.next) {
            this.transfer(var1, var3, var3.next);
            ++this.myLength;
            --var2.myLength;
         }
      } catch (Throwable var6) {
         throw var6;
      }

   }

   private DListNode insert(DListNode var1, Object var2) {
      DListNode var3 = new DListNode(this);
      var3.object = var2;
      var3.next = var1;
      var3.previous = var1.previous;
      var1.previous.next = var3;
      var1.previous = var3;
      ++this.myLength;
      return var3;
   }

   private void insert(DListNode var1, DListNode var2, DListNode var3) {
      while(var2 != var3) {
         this.insert(var1, var2.object);
         var2 = var2.next;
      }

   }

   private void transfer(DListNode var1, DListNode var2, DListNode var3) {
      if (var1 != var2 && var1 != var3) {
         var3.previous.next = var1;
         var2.previous.next = var3;
         var1.previous.next = var2;
         DListNode var4 = var1.previous;
         var1.previous = var3.previous;
         var3.previous = var2.previous;
         var2.previous = var4;
      }

   }

   private Object remove(DListNode var1) {
      var1.previous.next = var1.next;
      var1.next.previous = var1.previous;
      --this.myLength;
      return var1.object;
   }

   private int remove(DListNode var1, DListNode var2) {
      int var3;
      for(var3 = 0; var1 != var2; var1 = var1.next) {
         var1.previous.next = var1.next;
         var1.next.previous = var1.previous;
         ++var3;
      }

      this.myLength -= var3;
      return var3;
   }

   private int remove(DListNode var1, DListNode var2, Object var3, int var4) {
      if (var4 <= 0) {
         return 0;
      } else {
         int var5 = 0;

         for(DListNode var6 = var1; var4 > 0 && var6 != var2; var6 = var6.next) {
            if (var6.object.equals(var3)) {
               var6.previous.next = var6.next;
               var6.next.previous = var6.previous;
               ++var5;
               --var4;
            }
         }

         this.myLength -= var5;
         return var5;
      }
   }

   private DListIterator iteratorAt(int var1) {
      DListNode var2;
      for(var2 = this.myNode.next; var1-- > 0; var2 = var2.next) {
      }

      return new DListIterator(this, var2);
   }

   private DListNode nodeAt(int var1) {
      DListNode var2;
      for(var2 = this.myNode.next; var1-- > 0; var2 = var2.next) {
      }

      return var2;
   }

   private void checkRange(int var1, int var2) {
      if (var1 >= 0 && var1 < this.myLength) {
         if (var2 < 0 || var2 >= this.myLength) {
            throw new IndexOutOfBoundsException("Attempt to access index " + var2 + " when valid range is 0.." + (this.myLength - 1));
         }
      } else {
         throw new IndexOutOfBoundsException("Attempt to access index " + var1 + " when valid range is 0.." + (this.myLength - 1));
      }
   }
}
