package COM.objectspace.jgl;

import java.io.Serializable;

public final class DListIterator implements BidirectionalIterator, Serializable {
   DList myDList;
   DList.DListNode myNode;

   public DListIterator() {
   }

   DListIterator(DList var1, DList.DListNode var2) {
      this.myDList = var1;
      this.myNode = var2;
   }

   public DListIterator(DListIterator var1) {
      this.myDList = var1.myDList;
      this.myNode = var1.myNode;
   }

   public Object clone() {
      return new DListIterator(this);
   }

   public boolean equals(Object var1) {
      if (var1 instanceof DListIterator) {
         DListIterator var2 = (DListIterator)var1;
         if (this.myNode == var2.myNode || false) {
            return true;
         }
      }

      return false;
   }

   public boolean equals(DListIterator var1) {
      return this.myNode == var1.myNode;
   }

   public boolean atBegin() {
      return this.myNode == this.myDList.myNode.next;
   }

   public boolean atEnd() {
      return this.myNode == this.myDList.myNode;
   }

   public boolean hasMoreElements() {
      return this.myNode != this.myDList.myNode;
   }

   public void advance() {
      this.myNode = this.myNode.next;
   }

   public void advance(int var1) {
      this.myNode = this.nodeAt(var1);
   }

   public void retreat() {
      this.myNode = this.myNode.previous;
   }

   public void retreat(int var1) {
      this.myNode = this.nodeAt(-var1);
   }

   public Object nextElement() {
      Object var1 = this.myNode.object;
      this.myNode = this.myNode.next;
      return var1;
   }

   public Object get() {
      return this.myNode.object;
   }

   public void put(Object var1) {
      this.myNode.object = var1;
   }

   public Object get(int var1) {
      return this.nodeAt(var1).object;
   }

   public void put(int var1, Object var2) {
      this.nodeAt(var1).object = var2;
   }

   public int distance(ForwardIterator var1) {
      return this.distance(this.myNode, ((DListIterator)var1).myNode);
   }

   public int index() {
      return this.distance(this.myDList.myNode.next, this.myNode);
   }

   private int distance(DList.DListNode var1, DList.DListNode var2) {
      int var3;
      for(var3 = 0; var1 != var2; var1 = var1.next) {
         ++var3;
      }

      return var3;
   }

   private DList.DListNode nodeAt(int var1) {
      DList.DListNode var2 = this.myNode;
      if (var1 >= 0) {
         while(var1-- > 0) {
            var2 = var2.next;
         }
      } else {
         while(var1++ < 0) {
            var2 = var2.previous;
         }
      }

      return var2;
   }

   public Container getContainer() {
      return this.myDList;
   }
}
