package COM.objectspace.jgl;

import java.io.Serializable;

public final class DoubleIterator implements RandomAccessIterator, Serializable {
   DoubleArray myDoubleArray;
   double[] myArray;
   int myIndex;

   public static DoubleIterator begin(double[] var0, DoubleArray var1) {
      return new DoubleIterator(var0, 0, var1);
   }

   public static DoubleIterator end(double[] var0, DoubleArray var1) {
      return new DoubleIterator(var0, var0.length, var1);
   }

   public DoubleIterator() {
   }

   public DoubleIterator(DoubleIterator var1) {
      this.myDoubleArray = var1.myDoubleArray;
      this.myArray = var1.myArray;
      this.myIndex = var1.myIndex;
   }

   public DoubleIterator(double[] var1, DoubleArray var2) {
      this(var1, 0, var2);
   }

   public DoubleIterator(double[] var1, int var2, DoubleArray var3) {
      this.myDoubleArray = var3;
      this.myArray = var1;
      this.myIndex = var2;
   }

   public Object clone() {
      return new DoubleIterator(this);
   }

   public int index() {
      return this.myIndex;
   }

   public boolean equals(Object var1) {
      if (var1 instanceof DoubleIterator) {
         DoubleIterator var2 = (DoubleIterator)var1;
         if (var2.myIndex == this.myIndex && (var2.myArray == this.myArray || false)) {
            return true;
         }
      }

      return false;
   }

   public boolean equals(DoubleIterator var1) {
      return var1.myIndex == this.myIndex && var1.myArray == this.myArray;
   }

   public boolean less(RandomAccessIterator var1) {
      return this.myIndex < ((DoubleIterator)var1).myIndex;
   }

   public Object get(int var1) {
      return new Double(this.myArray[this.myIndex + var1]);
   }

   public void put(int var1, Object var2) {
      this.myArray[this.myIndex + var1] = (Double)var2;
   }

   public boolean atBegin() {
      return this.myIndex == 0;
   }

   public boolean atEnd() {
      return this.myIndex == this.myArray.length;
   }

   public boolean hasMoreElements() {
      return this.myIndex < this.myArray.length;
   }

   public void advance() {
      ++this.myIndex;
   }

   public void advance(int var1) {
      this.myIndex += var1;
   }

   public void retreat() {
      --this.myIndex;
   }

   public void retreat(int var1) {
      this.myIndex -= var1;
   }

   public Object nextElement() {
      return new Double(this.myArray[this.myIndex++]);
   }

   public Object get() {
      return new Double(this.myArray[this.myIndex]);
   }

   public void put(Object var1) {
      this.myArray[this.myIndex] = (Double)var1;
   }

   public int distance(ForwardIterator var1) {
      return ((DoubleIterator)var1).myIndex - this.myIndex;
   }

   public Container getContainer() {
      return this.myDoubleArray;
   }
}
