package COM.objectspace.jgl;

public final class Filtering {
   private Filtering() {
   }

   public static ForwardIterator unique(ForwardIterator var0, ForwardIterator var1) {
      EqualTo var3 = new EqualTo();
      ForwardIterator var2 = (ForwardIterator)Finding.adjacentFind(var0, var1, var3);
      return (ForwardIterator)uniqueCopy(var2, var1, var2, var3);
   }

   public static ForwardIterator unique(Container var0) {
      ForwardIterator var1 = var0.start();
      ForwardIterator var2 = var0.finish();
      EqualTo var3 = new EqualTo();
      var1 = (ForwardIterator)Finding.adjacentFind(var1, var2, var3);
      return (ForwardIterator)uniqueCopy(var1, var2, var1, var3);
   }

   public static ForwardIterator unique(ForwardIterator var0, ForwardIterator var1, BinaryPredicate var2) {
      var0 = (ForwardIterator)Finding.adjacentFind(var0, var1, var2);
      return (ForwardIterator)uniqueCopy(var0, var1, var0, var2);
   }

   public static ForwardIterator unique(Container var0, BinaryPredicate var1) {
      ForwardIterator var2 = var0.start();
      ForwardIterator var3 = var0.finish();
      var2 = (ForwardIterator)Finding.adjacentFind(var2, var3, var1);
      return (ForwardIterator)uniqueCopy(var2, var3, var2, var1);
   }

   public static OutputIterator uniqueCopy(InputIterator var0, InputIterator var1, OutputIterator var2) {
      return uniqueCopy(var0, var1, var2, new EqualTo());
   }

   public static OutputIterator uniqueCopy(Container var0, OutputIterator var1) {
      return uniqueCopy(var0.start(), var0.finish(), var1, new EqualTo());
   }

   public static void uniqueCopy(Container var0, Container var1) {
      uniqueCopy(var0.start(), var0.finish(), new InsertIterator(var1), new EqualTo());
   }

   public static OutputIterator uniqueCopy(InputIterator var0, InputIterator var1, OutputIterator var2, BinaryPredicate var3) {
      if (var0.equals(var1)) {
         return (OutputIterator)var2.clone();
      } else if (var2 instanceof ForwardIterator) {
         ForwardIterator var7 = (ForwardIterator)var2.clone();
         InputIterator var8 = (InputIterator)var0.clone();
         var7.put(var8.nextElement());

         for(; !var8.equals(var1); var8.advance()) {
            if (!var3.execute(var7.get(), var8.get())) {
               var7.advance();
               var7.put(var8.get());
            }
         }

         var7.advance();
         return var7;
      } else {
         OutputIterator var4 = (OutputIterator)var2.clone();
         InputIterator var5 = (InputIterator)var0.clone();
         Object var6 = var5.get();
         var4.put(var6);
         var5.advance();

         for(; !var5.equals(var1); var5.advance()) {
            if (!var3.execute(var6, var5.get())) {
               var6 = var5.get();
               var4.advance();
               var4.put(var6);
            }
         }

         var4.advance();
         return var4;
      }
   }

   public static OutputIterator uniqueCopy(Container var0, OutputIterator var1, BinaryPredicate var2) {
      return uniqueCopy(var0.start(), var0.finish(), var1, var2);
   }

   public static void uniqueCopy(Container var0, Container var1, BinaryPredicate var2) {
      uniqueCopy(var0.start(), var0.finish(), new InsertIterator(var1), var2);
   }

   public static Container select(ForwardIterator var0, ForwardIterator var1, UnaryPredicate var2) {
      Class var3 = var0.getContainer().getClass();
      Class var4 = var1.getContainer().getClass();
      if (var3 != var4) {
         throw new IllegalArgumentException("iterator containers must be the same");
      } else {
         return select(var0, var1, var2, (Container)var0.getContainer().clone());
      }
   }

   public static Container select(Container var0, UnaryPredicate var1) {
      Container var2 = (Container)var0.clone();

      try {
         var2.remove(Removing.removeIf(var2.start(), var2.finish(), new UnaryNot(var1)), var2.finish());
         return var2;
      } catch (IllegalArgumentException var3) {
         return select(var0.start(), var0.finish(), var1, var2);
      }
   }

   public static Container reject(ForwardIterator var0, ForwardIterator var1, UnaryPredicate var2) {
      return select(var0, var1, new UnaryNot(var2));
   }

   public static Container reject(Container var0, UnaryPredicate var1) {
      Container var2 = (Container)var0.clone();

      try {
         var2.remove(Removing.removeIf(var2.start(), var2.finish(), var1), var2.finish());
         return var2;
      } catch (IllegalArgumentException var3) {
         return select(var2.start(), var2.finish(), new UnaryNot(var1), var2);
      }
   }

   private static Container select(ForwardIterator var0, ForwardIterator var1, UnaryPredicate var2, Container var3) {
      var3.clear();
      ForwardIterator var4 = (ForwardIterator)var0.clone();

      while(!var4.equals(var1)) {
         Object var5 = var4.nextElement();
         if (var2.execute(var5)) {
            var3.add(var5);
         }
      }

      return var3;
   }
}
