package COM.objectspace.jgl;

import java.io.Serializable;

public final class FloatIterator implements RandomAccessIterator, Serializable {
   FloatArray myFloatArray;
   float[] myArray;
   int myIndex;

   public static FloatIterator begin(float[] var0) {
      return new FloatIterator(var0, 0, new FloatArray(var0));
   }

   public static FloatIterator begin(float[] var0, FloatArray var1) {
      return new FloatIterator(var0, 0, var1);
   }

   public static FloatIterator end(float[] var0) {
      return new FloatIterator(var0, var0.length, new FloatArray(var0));
   }

   public static FloatIterator end(float[] var0, FloatArray var1) {
      return new FloatIterator(var0, var0.length, var1);
   }

   public FloatIterator() {
   }

   public FloatIterator(FloatIterator var1) {
      this.myFloatArray = var1.myFloatArray;
      this.myArray = var1.myArray;
      this.myIndex = var1.myIndex;
   }

   public FloatIterator(float[] var1) {
      this(var1, 0, new FloatArray(var1));
   }

   public FloatIterator(float[] var1, FloatArray var2) {
      this(var1, 0, var2);
   }

   public FloatIterator(float[] var1, int var2) {
      this(var1, var2, new FloatArray(var1));
   }

   public FloatIterator(float[] var1, int var2, FloatArray var3) {
      this.myFloatArray = var3;
      this.myArray = var1;
      this.myIndex = var2;
   }

   public Object clone() {
      return new FloatIterator(this);
   }

   public int index() {
      return this.myIndex;
   }

   public boolean equals(Object var1) {
      if (var1 instanceof FloatIterator) {
         FloatIterator var2 = (FloatIterator)var1;
         if (var2.myIndex == this.myIndex && (var2.myArray == this.myArray || false)) {
            return true;
         }
      }

      return false;
   }

   public boolean equals(FloatIterator var1) {
      return var1.myIndex == this.myIndex && var1.myArray == this.myArray;
   }

   public boolean less(RandomAccessIterator var1) {
      return this.myIndex < ((FloatIterator)var1).myIndex;
   }

   public Object get(int var1) {
      return new Float(this.myArray[this.myIndex + var1]);
   }

   public void put(int var1, Object var2) {
      this.myArray[this.myIndex + var1] = (Float)var2;
   }

   public boolean atBegin() {
      return this.myIndex == 0;
   }

   public boolean atEnd() {
      return this.myIndex == this.myArray.length;
   }

   public boolean hasMoreElements() {
      return this.myIndex < this.myArray.length;
   }

   public void advance() {
      ++this.myIndex;
   }

   public void advance(int var1) {
      this.myIndex += var1;
   }

   public void retreat() {
      --this.myIndex;
   }

   public void retreat(int var1) {
      this.myIndex -= var1;
   }

   public Object nextElement() {
      return new Float(this.myArray[this.myIndex++]);
   }

   public Object get() {
      return new Float(this.myArray[this.myIndex]);
   }

   public void put(Object var1) {
      this.myArray[this.myIndex] = (Float)var1;
   }

   public int distance(ForwardIterator var1) {
      return ((FloatIterator)var1).myIndex - this.myIndex;
   }

   public Container getContainer() {
      return this.myFloatArray;
   }
}
