package COM.objectspace.jgl;

public final class Hashing {
   static final int HASH_SIZE = 16;

   public static int orderedHash(Container var0) {
      return orderedHash(var0.start(), var0.finish());
   }

   public static int orderedHash(ForwardIterator var0, ForwardIterator var1) {
      int var2 = 0;
      int var3 = var0.distance(var1);
      int var4 = 0;
      int var5 = 1;
      if (var3 >= 16) {
         var5 = var3 / 16;
         var0.advance(var3 % 16);
      }

      while(!var0.equals(var1)) {
         if (var0.get() != null) {
            var2 ^= var0.get().hashCode() / (var4 % 16 + 1);
         }

         ++var4;
         var0.advance(var5);
      }

      return var2;
   }

   public static int unorderedHash(Container var0) {
      return unorderedHash(var0.start(), var0.finish());
   }

   public static int unorderedHash(ForwardIterator var0, ForwardIterator var1) {
      int var2;
      for(var2 = 0; !var0.equals(var1); var0.advance()) {
         if (var0.get() != null) {
            var2 ^= var0.get().hashCode();
         }
      }

      return var2;
   }
}
