package COM.objectspace.jgl;

import java.io.Serializable;

public final class IntIterator implements RandomAccessIterator, Serializable {
   IntArray myIntArray;
   int[] myArray;
   int myIndex;

   public static IntIterator begin(int[] var0) {
      return new IntIterator(var0, 0, new IntArray(var0));
   }

   public static IntIterator begin(int[] var0, IntArray var1) {
      return new IntIterator(var0, 0, var1);
   }

   public static IntIterator end(int[] var0) {
      return new IntIterator(var0, var0.length, new IntArray(var0));
   }

   public static IntIterator end(int[] var0, IntArray var1) {
      return new IntIterator(var0, var0.length, var1);
   }

   public IntIterator() {
   }

   public IntIterator(int[] var1) {
      this(var1, 0, new IntArray(var1));
   }

   public IntIterator(int[] var1, IntArray var2) {
      this(var1, 0, var2);
   }

   public IntIterator(IntIterator var1) {
      this.myIntArray = var1.myIntArray;
      this.myArray = var1.myArray;
      this.myIndex = var1.myIndex;
   }

   public IntIterator(int[] var1, int var2) {
      this(var1, var2, new IntArray(var1));
   }

   public IntIterator(int[] var1, int var2, IntArray var3) {
      this.myIntArray = var3;
      this.myArray = var1;
      this.myIndex = var2;
   }

   public int index() {
      return this.myIndex;
   }

   public Object clone() {
      return new IntIterator(this);
   }

   public boolean equals(Object var1) {
      if (var1 instanceof IntIterator) {
         IntIterator var2 = (IntIterator)var1;
         if (var2.myIndex == this.myIndex && (var2.myArray == this.myArray || false)) {
            return true;
         }
      }

      return false;
   }

   public boolean equals(IntIterator var1) {
      return var1.myIndex == this.myIndex && var1.myArray == this.myArray;
   }

   public boolean less(RandomAccessIterator var1) {
      return this.myIndex < ((IntIterator)var1).myIndex;
   }

   public Object get(int var1) {
      return new Integer(this.myArray[this.myIndex + var1]);
   }

   public void put(int var1, Object var2) {
      this.myArray[this.myIndex + var1] = (Integer)var2;
   }

   public boolean atBegin() {
      return this.myIndex == 0;
   }

   public boolean atEnd() {
      return this.myIndex == this.myArray.length;
   }

   public boolean hasMoreElements() {
      return this.myIndex < this.myArray.length;
   }

   public void advance() {
      ++this.myIndex;
   }

   public void advance(int var1) {
      this.myIndex += var1;
   }

   public void retreat() {
      --this.myIndex;
   }

   public void retreat(int var1) {
      this.myIndex -= var1;
   }

   public Object nextElement() {
      return new Integer(this.myArray[this.myIndex++]);
   }

   public Object get() {
      return new Integer(this.myArray[this.myIndex]);
   }

   public void put(Object var1) {
      this.myArray[this.myIndex] = (Integer)var1;
   }

   public int distance(ForwardIterator var1) {
      return ((IntIterator)var1).myIndex - this.myIndex;
   }

   public Container getContainer() {
      return this.myIntArray;
   }
}
