package COM.objectspace.jgl;

import java.io.Serializable;

public final class LongIterator implements RandomAccessIterator, Serializable {
   LongArray myLongArray;
   long[] myArray;
   int myIndex;

   public static LongIterator begin(long[] var0) {
      return new LongIterator(var0, 0, new LongArray(var0));
   }

   public static LongIterator begin(long[] var0, LongArray var1) {
      return new LongIterator(var0, 0, var1);
   }

   public static LongIterator end(long[] var0) {
      return new LongIterator(var0, var0.length, new LongArray(var0));
   }

   public static LongIterator end(long[] var0, LongArray var1) {
      return new LongIterator(var0, var0.length, var1);
   }

   public LongIterator() {
   }

   public LongIterator(LongIterator var1) {
      this.myLongArray = var1.myLongArray;
      this.myArray = var1.myArray;
      this.myIndex = var1.myIndex;
   }

   public LongIterator(long[] var1) {
      this(var1, 0, new LongArray(var1));
   }

   public LongIterator(long[] var1, LongArray var2) {
      this(var1, 0, var2);
   }

   public LongIterator(long[] var1, int var2) {
      this(var1, var2, new LongArray(var1));
   }

   public LongIterator(long[] var1, int var2, LongArray var3) {
      this.myLongArray = var3;
      this.myArray = var1;
      this.myIndex = var2;
   }

   public Object clone() {
      return new LongIterator(this);
   }

   public int index() {
      return this.myIndex;
   }

   public boolean equals(Object var1) {
      if (var1 instanceof LongIterator) {
         LongIterator var2 = (LongIterator)var1;
         if (var2.myIndex == this.myIndex && (var2.myArray == this.myArray || false)) {
            return true;
         }
      }

      return false;
   }

   public boolean equals(LongIterator var1) {
      return var1.myIndex == this.myIndex && var1.myArray == this.myArray;
   }

   public boolean less(RandomAccessIterator var1) {
      return this.myIndex < ((LongIterator)var1).myIndex;
   }

   public Object get(int var1) {
      return new Long(this.myArray[this.myIndex + var1]);
   }

   public void put(int var1, Object var2) {
      this.myArray[this.myIndex + var1] = (Long)var2;
   }

   public boolean atBegin() {
      return this.myIndex == 0;
   }

   public boolean atEnd() {
      return this.myIndex == this.myArray.length;
   }

   public boolean hasMoreElements() {
      return this.myIndex < this.myArray.length;
   }

   public void advance() {
      ++this.myIndex;
   }

   public void advance(int var1) {
      this.myIndex += var1;
   }

   public void retreat() {
      --this.myIndex;
   }

   public void retreat(int var1) {
      this.myIndex -= var1;
   }

   public Object nextElement() {
      return new Long(this.myArray[this.myIndex++]);
   }

   public Object get() {
      return new Long(this.myArray[this.myIndex]);
   }

   public void put(Object var1) {
      this.myArray[this.myIndex] = (Long)var1;
   }

   public int distance(ForwardIterator var1) {
      return ((LongIterator)var1).myIndex - this.myIndex;
   }

   public Container getContainer() {
      return this.myLongArray;
   }
}
