package COM.objectspace.jgl;

public final class MinMax {
   private MinMax() {
   }

   public static InputIterator maxElement(InputIterator var0, InputIterator var1) {
      return maxElement(var0, var1, new HashComparator());
   }

   public static InputIterator maxElement(Container var0) {
      return maxElement(var0.start(), var0.finish(), new HashComparator());
   }

   public static InputIterator maxElement(InputIterator var0, InputIterator var1, BinaryPredicate var2) {
      InputIterator var3 = (InputIterator)var0.clone();
      if (var3.equals(var1)) {
         return var3;
      } else {
         InputIterator var4 = (InputIterator)var3.clone();
         var3.advance();

         for(; !var3.equals(var1); var3.advance()) {
            if (var2.execute(var4.get(), var3.get())) {
               var4 = (InputIterator)var3.clone();
            }
         }

         return var4;
      }
   }

   public static InputIterator maxElement(Container var0, BinaryPredicate var1) {
      return maxElement(var0.start(), var0.finish(), var1);
   }

   public static InputIterator minElement(InputIterator var0, InputIterator var1) {
      return minElement(var0, var1, new HashComparator());
   }

   public static InputIterator minElement(Container var0) {
      return minElement(var0.start(), var0.finish(), new HashComparator());
   }

   public static InputIterator minElement(InputIterator var0, InputIterator var1, BinaryPredicate var2) {
      InputIterator var3 = (InputIterator)var0.clone();
      if (var3.equals(var1)) {
         return var3;
      } else {
         InputIterator var4 = (InputIterator)var3.clone();
         var3.advance();

         for(; !var3.equals(var1); var3.advance()) {
            if (var2.execute(var3.get(), var4.get())) {
               var4 = (InputIterator)var3.clone();
            }
         }

         return var4;
      }
   }

   public static InputIterator minElement(Container var0, BinaryPredicate var1) {
      return minElement(var0.start(), var0.finish(), var1);
   }
}
