package COM.objectspace.jgl;

import java.io.Serializable;

public final class ObjectIterator implements RandomAccessIterator, Serializable {
   ObjectArray myObjectArray;
   Object[] myArray;
   int myIndex;

   public static ObjectIterator begin(Object[] var0) {
      return new ObjectIterator(var0, 0, new ObjectArray(var0));
   }

   public static ObjectIterator begin(Object[] var0, ObjectArray var1) {
      return new ObjectIterator(var0, 0, var1);
   }

   public static ObjectIterator end(Object[] var0) {
      return new ObjectIterator(var0, var0.length, new ObjectArray(var0));
   }

   public static ObjectIterator end(Object[] var0, ObjectArray var1) {
      return new ObjectIterator(var0, var0.length, var1);
   }

   public ObjectIterator() {
   }

   public ObjectIterator(ObjectIterator var1) {
      this.myObjectArray = var1.myObjectArray;
      this.myArray = var1.myArray;
      this.myIndex = var1.myIndex;
   }

   public ObjectIterator(Object[] var1) {
      this(var1, 0, new ObjectArray(var1));
   }

   public ObjectIterator(Object[] var1, ObjectArray var2) {
      this(var1, 0, var2);
   }

   public ObjectIterator(Object[] var1, int var2) {
      this(var1, var2, new ObjectArray(var1));
   }

   public ObjectIterator(Object[] var1, int var2, ObjectArray var3) {
      this.myObjectArray = var3;
      this.myArray = var1;
      this.myIndex = var2;
   }

   public int index() {
      return this.myIndex;
   }

   public Object clone() {
      return new ObjectIterator(this);
   }

   public boolean equals(Object var1) {
      if (var1 instanceof ObjectIterator) {
         ObjectIterator var2 = (ObjectIterator)var1;
         if (var2.myIndex == this.myIndex && (var2.myArray == this.myArray || false)) {
            return true;
         }
      }

      return false;
   }

   public boolean equals(ObjectIterator var1) {
      return var1.myIndex == this.myIndex && var1.myArray == this.myArray;
   }

   public boolean less(RandomAccessIterator var1) {
      return this.myIndex < ((ObjectIterator)var1).myIndex;
   }

   public Object get(int var1) {
      return this.myArray[this.myIndex + var1];
   }

   public void put(int var1, Object var2) {
      this.myArray[this.myIndex + var1] = var2;
   }

   public boolean atBegin() {
      return this.myIndex == 0;
   }

   public boolean atEnd() {
      return this.myIndex == this.myArray.length;
   }

   public boolean hasMoreElements() {
      return this.myIndex < this.myArray.length;
   }

   public void advance() {
      ++this.myIndex;
   }

   public void advance(int var1) {
      this.myIndex += var1;
   }

   public void retreat() {
      --this.myIndex;
   }

   public void retreat(int var1) {
      this.myIndex -= var1;
   }

   public Object nextElement() {
      return this.myArray[this.myIndex++];
   }

   public Object get() {
      return this.myArray[this.myIndex];
   }

   public void put(Object var1) {
      this.myArray[this.myIndex] = var1;
   }

   public int distance(ForwardIterator var1) {
      return ((ObjectIterator)var1).myIndex - this.myIndex;
   }

   public Container getContainer() {
      return this.myObjectArray;
   }
}
