package COM.objectspace.jgl;

public final class OrderedSetIterator implements BidirectionalIterator {
   OrderedSet myOrderedSet;
   Tree myTree;
   Tree.TreeNode myNode;

   public OrderedSetIterator() {
   }

   public OrderedSetIterator(OrderedSetIterator var1) {
      this.myOrderedSet = var1.myOrderedSet;
      this.myTree = var1.myTree;
      this.myNode = var1.myNode;
   }

   OrderedSetIterator(Tree var1, Tree.TreeNode var2, OrderedSet var3) {
      this.myOrderedSet = var3;
      this.myTree = var1;
      this.myNode = var2;
   }

   public Object clone() {
      return new OrderedSetIterator(this);
   }

   public boolean equals(Object var1) {
      if (var1 instanceof OrderedSetIterator) {
         OrderedSetIterator var2 = (OrderedSetIterator)var1;
         if (this.myNode == var2.myNode || false) {
            return true;
         }
      }

      return false;
   }

   public boolean equals(OrderedSetIterator var1) {
      return this.myNode == var1.myNode;
   }

   public boolean atBegin() {
      return this.myNode == this.myTree.myHeader.left;
   }

   public boolean atEnd() {
      return this.myNode == this.myTree.myHeader;
   }

   public boolean hasMoreElements() {
      return this.myNode != this.myTree.myHeader;
   }

   public void advance() {
      this.myNode = Tree.increment(this.myNode, this.myTree.NIL);
   }

   public void advance(int var1) {
      if (var1 >= 0) {
         while(var1-- > 0) {
            this.myNode = Tree.increment(this.myNode, this.myTree.NIL);
         }

      } else {
         while(var1++ < 0) {
            this.myNode = Tree.decrement(this.myNode, this.myTree.NIL);
         }

      }
   }

   public void retreat() {
      this.myNode = Tree.decrement(this.myNode, this.myTree.NIL);
   }

   public void retreat(int var1) {
      int var2 = -var1;
      if (var2 >= 0) {
         while(var2-- > 0) {
            this.myNode = Tree.increment(this.myNode, this.myTree.NIL);
         }

      } else {
         while(var2++ < 0) {
            this.myNode = Tree.decrement(this.myNode, this.myTree.NIL);
         }

      }
   }

   public Object nextElement() {
      Object var1 = this.myNode.object;
      this.myNode = Tree.increment(this.myNode, this.myTree.NIL);
      return var1;
   }

   public Object get() {
      return this.myNode.object;
   }

   public void put(Object var1) {
      this.myNode.object = var1;
   }

   public Object get(int var1) {
      Tree.TreeNode var2 = this.myNode;
      int var3 = var1;
      if (var1 >= 0) {
         while(var3-- > 0) {
            this.myNode = Tree.increment(this.myNode, this.myTree.NIL);
         }
      } else {
         while(var3++ < 0) {
            this.myNode = Tree.decrement(this.myNode, this.myTree.NIL);
         }
      }

      Object var4 = this.myNode.object;
      this.myNode = var2;
      return var4;
   }

   public void put(int var1, Object var2) {
      Tree.TreeNode var3 = this.myNode;
      int var4 = var1;
      if (var1 >= 0) {
         while(var4-- > 0) {
            this.myNode = Tree.increment(this.myNode, this.myTree.NIL);
         }
      } else {
         while(var4++ < 0) {
            this.myNode = Tree.decrement(this.myNode, this.myTree.NIL);
         }
      }

      this.myNode.object = var2;
      this.myNode = var3;
   }

   public int distance(ForwardIterator var1) {
      Tree.TreeNode var2 = ((OrderedSetIterator)var1).myNode;

      int var3;
      for(var3 = 0; var2 != this.myNode; var2 = Tree.decrement(var2, this.myTree.NIL)) {
         ++var3;
      }

      return var3;
   }

   public Container getContainer() {
      return this.myOrderedSet;
   }
}
