package COM.objectspace.jgl;

import java.util.Random;

public class Randomizer extends Random {
   static Randomizer random = new Randomizer();

   public Randomizer() {
   }

   public Randomizer(long var1) {
      super(var1);
   }

   public int nextInt(int var1) {
      return this.nextInt(1, var1);
   }

   public int nextInt(int var1, int var2) {
      if (var1 > var2) {
         throw new InvalidOperationException("invalid range: " + var1 + " > " + var2);
      } else {
         return Math.abs(super.nextInt()) % (var2 - var1 + 1) + var1;
      }
   }

   public long nextLong(long var1) {
      return this.nextLong(1L, var1);
   }

   public long nextLong(long var1, long var3) {
      if (var1 > var3) {
         throw new InvalidOperationException("invalid range: " + var1 + " > " + var3);
      } else {
         return Math.abs(super.nextLong()) % (var3 - var1 + 1L) + var1;
      }
   }

   public float nextFloat(float var1) {
      return this.nextFloat(1.0F, var1);
   }

   public float nextFloat(float var1, float var2) {
      if (var1 > var2) {
         throw new InvalidOperationException("invalid range: " + var1 + " > " + var2);
      } else {
         return Math.abs(super.nextFloat()) % (var2 - var1 + 1.0F) + var1;
      }
   }

   public double nextDouble(double var1) {
      return this.nextDouble((double)1.0F, var1);
   }

   public double nextDouble(double var1, double var3) {
      if (var1 > var3) {
         throw new InvalidOperationException("invalid range: " + var1 + " > " + var3);
      } else {
         return Math.abs(super.nextDouble()) % (var3 - var1 + (double)1.0F) + var1;
      }
   }

   public static int getInt(int var0) {
      return random.nextInt(1, var0);
   }

   public static int getInt(int var0, int var1) {
      return random.nextInt(var0, var1);
   }

   public static long getLong(long var0) {
      return random.nextLong(1L, var0);
   }

   public static long getLong(long var0, long var2) {
      return random.nextLong(var0, var2);
   }

   public static float getFloat(float var0) {
      return random.nextFloat(1.0F, var0);
   }

   public static float getFloat(float var0, float var1) {
      return random.nextFloat(var0, var1);
   }

   public static double getDouble(double var0) {
      return random.nextDouble((double)1.0F, var0);
   }

   public static double getDouble(double var0, double var2) {
      return random.nextDouble(var0, var2);
   }
}
