package COM.objectspace.jgl;

public final class Removing {
   private Removing() {
   }

   public static ForwardIterator remove(ForwardIterator var0, ForwardIterator var1, Object var2) {
      if (!(var0.getContainer() instanceof Sequence)) {
         throw new IllegalArgumentException("iterator containers must be a Sequence");
      } else {
         var0 = (ForwardIterator)Finding.find(var0, var1, var2);
         if (var0.equals(var1)) {
            return var0;
         } else {
            ForwardIterator var3 = (ForwardIterator)var0.clone();
            var3.advance();
            return (ForwardIterator)removeCopy(var3, var1, var0, var2);
         }
      }
   }

   public static ForwardIterator remove(Sequence var0, Object var1) {
      return remove(var0.start(), var0.finish(), var1);
   }

   public static ForwardIterator removeIf(ForwardIterator var0, ForwardIterator var1, UnaryPredicate var2) {
      if (!(var0.getContainer() instanceof Sequence)) {
         throw new IllegalArgumentException("iterator containers must be a Sequence");
      } else {
         var0 = (ForwardIterator)Finding.findIf(var0, var1, var2);
         if (var0.equals(var1)) {
            return var0;
         } else {
            ForwardIterator var3 = (ForwardIterator)var0.clone();
            var3.advance();
            return (ForwardIterator)removeCopyIf(var3, var1, var0, var2);
         }
      }
   }

   public static ForwardIterator removeIf(Sequence var0, UnaryPredicate var1) {
      return removeIf(var0.start(), var0.finish(), var1);
   }

   public static OutputIterator removeCopy(InputIterator var0, InputIterator var1, OutputIterator var2, Object var3) {
      InputIterator var4 = (InputIterator)var0.clone();

      OutputIterator var5;
      for(var5 = (OutputIterator)var2.clone(); !var4.equals(var1); var4.advance()) {
         if (!var4.get().equals(var3)) {
            var5.put(var4.get());
            var5.advance();
         }
      }

      return var5;
   }

   public static OutputIterator removeCopy(Container var0, OutputIterator var1, Object var2) {
      return removeCopy(var0.start(), var0.finish(), var1, var2);
   }

   public static void removeCopy(Container var0, Container var1, Object var2) {
      removeCopy(var0.start(), var0.finish(), new InsertIterator(var1), var2);
   }

   public static OutputIterator removeCopyIf(InputIterator var0, InputIterator var1, OutputIterator var2, UnaryPredicate var3) {
      InputIterator var4 = (InputIterator)var0.clone();

      OutputIterator var5;
      for(var5 = (OutputIterator)var2.clone(); !var4.equals(var1); var4.advance()) {
         if (!var3.execute(var4.get())) {
            var5.put(var4.get());
            var5.advance();
         }
      }

      return var5;
   }

   public static OutputIterator removeCopyIf(Container var0, OutputIterator var1, UnaryPredicate var2) {
      return removeCopyIf(var0.start(), var0.finish(), var1, var2);
   }

   public static void removeCopyIf(Container var0, Container var1, UnaryPredicate var2) {
      removeCopyIf(var0.start(), var0.finish(), new InsertIterator(var1), var2);
   }
}
