package COM.objectspace.jgl;

public final class Replacing {
   private Replacing() {
   }

   public static int replace(ForwardIterator var0, ForwardIterator var1, Object var2, Object var3) {
      ForwardIterator var4 = (ForwardIterator)var0.clone();

      int var5;
      for(var5 = 0; !var4.equals(var1); var4.advance()) {
         if (var4.get().equals(var2)) {
            var4.put(var3);
            ++var5;
         }
      }

      return var5;
   }

   public static int replace(Container var0, Object var1, Object var2) {
      return replace(var0.start(), var0.finish(), var1, var2);
   }

   public static int replaceIf(ForwardIterator var0, ForwardIterator var1, UnaryPredicate var2, Object var3) {
      ForwardIterator var4 = (ForwardIterator)var0.clone();

      int var5;
      for(var5 = 0; !var4.equals(var1); var4.advance()) {
         if (var2.execute(var4.get())) {
            var4.put(var3);
            ++var5;
         }
      }

      return var5;
   }

   public static int replaceIf(Container var0, UnaryPredicate var1, Object var2) {
      return replaceIf(var0.start(), var0.finish(), var1, var2);
   }

   public static OutputIterator replaceCopy(InputIterator var0, InputIterator var1, OutputIterator var2, Object var3, Object var4) {
      InputIterator var5 = (InputIterator)var0.clone();
      OutputIterator var6 = (OutputIterator)var2.clone();

      while(!var5.equals(var1)) {
         var6.put(var5.get().equals(var3) ? var4 : var5.get());
         var6.advance();
         var5.advance();
      }

      return var6;
   }

   public static OutputIterator replaceCopy(Container var0, OutputIterator var1, Object var2, Object var3) {
      return replaceCopy(var0.start(), var0.finish(), var1, var2, var3);
   }

   public static void replaceCopy(Container var0, Container var1, Object var2, Object var3) {
      replaceCopy(var0.start(), var0.finish(), new InsertIterator(var1), var2, var3);
   }

   public static OutputIterator replaceCopyIf(InputIterator var0, InputIterator var1, OutputIterator var2, UnaryPredicate var3, Object var4) {
      InputIterator var5 = (InputIterator)var0.clone();
      OutputIterator var6 = (OutputIterator)var2.clone();

      while(!var5.equals(var1)) {
         var6.put(var3.execute(var5.get()) ? var4 : var5.get());
         var6.advance();
         var5.advance();
      }

      return var6;
   }

   public static OutputIterator replaceCopyIf(Container var0, OutputIterator var1, UnaryPredicate var2, Object var3) {
      return replaceCopyIf(var0.start(), var0.finish(), var1, var2, var3);
   }

   public static void replaceCopyIf(Container var0, Container var1, UnaryPredicate var2, Object var3) {
      replaceCopyIf(var0.start(), var0.finish(), new InsertIterator(var1), var2, var3);
   }
}
