package COM.objectspace.jgl;

public final class ReverseIterator implements BidirectionalIterator {
   BidirectionalIterator myIterator;

   public ReverseIterator(BidirectionalIterator var1) {
      this.myIterator = var1;
   }

   public ReverseIterator(ReverseIterator var1) {
      this.myIterator = (BidirectionalIterator)var1.myIterator.clone();
   }

   public Object clone() {
      return new ReverseIterator(this);
   }

   public boolean atEnd() {
      return this.myIterator.atBegin();
   }

   public boolean atBegin() {
      return this.myIterator.atEnd();
   }

   public boolean equals(Object var1) {
      if (var1 instanceof ReverseIterator) {
         ReverseIterator var2 = (ReverseIterator)var1;
         if (this.myIterator.equals(var2.myIterator)) {
            return true;
         }
      }

      return false;
   }

   public boolean equals(ReverseIterator var1) {
      return this.myIterator.equals(var1.myIterator);
   }

   public boolean hasMoreElements() {
      return !this.myIterator.atBegin();
   }

   public void advance() {
      this.myIterator.retreat();
   }

   public void advance(int var1) {
      this.myIterator.retreat(var1);
   }

   public void retreat() {
      this.myIterator.advance();
   }

   public void retreat(int var1) {
      this.myIterator.advance(var1);
   }

   public Object nextElement() {
      this.myIterator.retreat();
      return this.myIterator.get();
   }

   public Object get() {
      this.myIterator.retreat();
      Object var1 = this.myIterator.get();
      this.myIterator.advance();
      return var1;
   }

   public void put(Object var1) {
      this.myIterator.retreat();
      this.myIterator.put(var1);
      this.myIterator.advance();
   }

   public int distance(ForwardIterator var1) {
      return var1.distance(this);
   }

   public Object get(int var1) {
      return this.myIterator.get(-(var1 + 1));
   }

   public void put(int var1, Object var2) {
      this.myIterator.put(-(var1 + 1), var2);
   }

   public Container getContainer() {
      return this.myIterator.getContainer();
   }
}
