package COM.objectspace.jgl;

import java.util.Enumeration;

public class SList implements Sequence {
   SListNode myHead;
   SListNode myTail;
   int myLength;

   public SList() {
   }

   public SList(int var1) {
      while(true) {
         --var1;
         if (var1 < 0) {
            return;
         }

         this.add((Object)null);
      }
   }

   public SList(int var1, Object var2) {
      while(true) {
         --var1;
         if (var1 < 0) {
            return;
         }

         this.add(var2);
      }
   }

   public SList(SList var1) {
      this.copy(var1);
   }

   public synchronized Object clone() {
      return new SList(this);
   }

   public boolean equals(Object var1) {
      return var1 instanceof SList && this.equals((SList)var1);
   }

   public synchronized boolean equals(SList var1) {
      synchronized(var1){}

      boolean var2;
      try {
         var2 = this.size() == var1.size() && Comparing.equal(this.start(), this.finish(), var1.start());
      } catch (Throwable var8) {
         throw var8;
      }

      return var2;
   }

   public synchronized int hashCode() {
      return Hashing.orderedHash(this.start(), this.finish());
   }

   public synchronized String toString() {
      return "SList" + Printing.toString(this.start(), this.finish());
   }

   public synchronized SListIterator begin() {
      return new SListIterator(this, this.myHead);
   }

   public synchronized SListIterator end() {
      return new SListIterator(this, (SListNode)null);
   }

   public synchronized Enumeration elements() {
      return new SListIterator(this, this.myHead);
   }

   public ForwardIterator start() {
      return this.begin();
   }

   public ForwardIterator finish() {
      return this.end();
   }

   public synchronized void copy(SList var1) {
      if (this != var1) {
         synchronized(var1){}

         try {
            this.myHead = null;
            this.myTail = null;

            for(SListNode var4 = var1.myHead; var4 != null; var4 = var4.next) {
               SListNode var5 = new SListNode(this);
               var5.object = var4.object;
               if (this.myTail == null) {
                  this.myHead = var5;
               } else {
                  this.myTail.next = var5;
               }

               this.myTail = var5;
            }

            this.myLength = var1.myLength;
         } catch (Throwable var7) {
            throw var7;
         }

      }
   }

   public boolean isEmpty() {
      return this.myLength == 0;
   }

   public int size() {
      return this.myLength;
   }

   public int maxSize() {
      return Integer.MAX_VALUE;
   }

   // $FF: renamed from: at (int) java.lang.Object
   public synchronized Object method_0(int var1) {
      if (var1 >= 0 && var1 < this.myLength) {
         SListNode var2;
         for(var2 = this.myHead; var1-- > 0; var2 = var2.next) {
         }

         return var2.object;
      } else {
         throw new IndexOutOfBoundsException("Attempt to access index " + var1 + " when valid range is 0.." + (this.myLength - 1));
      }
   }

   public synchronized void put(int var1, Object var2) {
      if (var1 >= 0 && var1 < this.myLength) {
         SListNode var3;
         for(var3 = this.myHead; var1-- > 0; var3 = var3.next) {
         }

         var3.object = var2;
      } else {
         throw new IndexOutOfBoundsException("Attempt to access index " + var1 + " when valid range is 0.." + (this.myLength - 1));
      }
   }

   public synchronized SListIterator insert(SListIterator var1, Object var2) {
      return new SListIterator(this, this.insert(var1.myNode, var2));
   }

   public synchronized void insert(int var1, Object var2) {
      if (var1 > this.myLength) {
         throw new IndexOutOfBoundsException("Attempt to insert at index " + var1 + " when valid range is 0.." + this.myLength);
      } else {
         this.insert(this.nodeAt(var1), var2);
      }
   }

   public synchronized void insert(SListIterator var1, int var2, Object var3) {
      this.insert(var1.myNode, var2, var3);
   }

   public synchronized void insert(int var1, int var2, Object var3) {
      if (var1 > this.myLength) {
         throw new IndexOutOfBoundsException("Attempt to insert at index " + var1 + " when valid range is 0.." + this.myLength);
      } else {
         this.insert(this.nodeAt(var1), var2, var3);
      }
   }

   public synchronized void insert(SListIterator var1, InputIterator var2, InputIterator var3) {
      InputIterator var4 = (InputIterator)var2.clone();

      while(!var4.equals(var3)) {
         this.insert(var1, var4.nextElement());
      }

   }

   public synchronized Object back() {
      if (this.myLength == 0) {
         throw new InvalidOperationException("SList is empty");
      } else {
         return this.myTail.object;
      }
   }

   public synchronized Object front() {
      if (this.myLength == 0) {
         throw new InvalidOperationException("SList is empty");
      } else {
         return this.myHead.object;
      }
   }

   public synchronized void clear() {
      this.myHead = null;
      this.myTail = null;
      this.myLength = 0;
   }

   public synchronized Object popBack() {
      if (this.myLength == 0) {
         throw new InvalidOperationException("SList is empty");
      } else {
         SListNode var1 = null;

         for(SListNode var2 = this.myHead; var2 != this.myTail; var2 = var2.next) {
            var1 = var2;
         }

         Object var3;
         if (var1 == null) {
            var3 = this.myHead.object;
            this.myHead = null;
         } else {
            var3 = var1.next.object;
            var1.next = null;
         }

         this.myTail = var1;
         --this.myLength;
         return var3;
      }
   }

   public synchronized void pushFront(Object var1) {
      SListNode var2 = new SListNode(this);
      var2.object = var1;
      var2.next = this.myHead;
      this.myHead = var2;
      if (++this.myLength == 1) {
         this.myTail = var2;
      }

   }

   public synchronized Object popFront() {
      if (this.myLength == 0) {
         throw new InvalidOperationException("Slist is empty");
      } else {
         Object var1 = this.myHead.object;
         this.myHead = this.myHead.next;
         if (--this.myLength == 0) {
            this.myTail = null;
         }

         return var1;
      }
   }

   public synchronized Object add(Object var1) {
      SListNode var2 = new SListNode(this);
      var2.object = var1;
      if (++this.myLength == 1) {
         this.myHead = var2;
      } else {
         this.myTail.next = var2;
      }

      this.myTail = var2;
      return null;
   }

   public void pushBack(Object var1) {
      this.add(var1);
   }

   public synchronized void swap(SList var1) {
      synchronized(var1){}

      try {
         SListNode var4 = this.myHead;
         this.myHead = var1.myHead;
         var1.myHead = var4;
         SListNode var5 = this.myTail;
         this.myTail = var1.myTail;
         var1.myTail = var5;
         int var6 = this.myLength;
         this.myLength = var1.myLength;
         var1.myLength = var6;
      } catch (Throwable var8) {
         throw var8;
      }

   }

   public synchronized int remove(Object var1) {
      return this.remove(this.myHead, (SListNode)null, var1, this.myLength);
   }

   public synchronized int remove(Object var1, int var2) {
      return this.remove(this.myHead, (SListNode)null, var1, var2);
   }

   public synchronized int remove(Enumeration var1, Enumeration var2, Object var3) {
      if (var1 instanceof SListIterator && var2 instanceof SListIterator) {
         if (((SListIterator)var1).mySList == this && ((SListIterator)var2).mySList == this) {
            SListIterator var4 = (SListIterator)var1;
            SListIterator var5 = (SListIterator)var2;
            return this.remove(var4.myNode, var5.myNode, var3, this.myLength);
         } else {
            throw new IllegalArgumentException("Enumeration not for this SList");
         }
      } else {
         throw new IllegalArgumentException("Enumeration not a SListIterator");
      }
   }

   public synchronized int remove(int var1, int var2, Object var3) {
      if (var2 < var1) {
         return 0;
      } else {
         this.checkRange(var1, var2);
         return this.remove(this.nodeAt(var1), this.nodeAt(var2 + 1), var3, this.myLength);
      }
   }

   public synchronized int replace(Object var1, Object var2) {
      return Replacing.replace(this.start(), this.finish(), var1, var2);
   }

   public synchronized int replace(SListIterator var1, SListIterator var2, Object var3, Object var4) {
      return Replacing.replace(var1, var2, var3, var4);
   }

   public synchronized int replace(int var1, int var2, Object var3, Object var4) {
      if (var2 < var1) {
         return 0;
      } else {
         this.checkRange(var1, var2);
         return Replacing.replace(this.iteratorAt(var1), this.iteratorAt(var2 + 1), var3, var4);
      }
   }

   public synchronized int count(Object var1) {
      return Counting.count(this.start(), this.finish(), var1);
   }

   public synchronized int count(SListIterator var1, SListIterator var2, Object var3) {
      return Counting.count(var1, var2, var3);
   }

   public synchronized int count(int var1, int var2, Object var3) {
      if (var2 < var1) {
         return 0;
      } else {
         this.checkRange(var1, var2);
         return Counting.count(this.iteratorAt(var1), this.iteratorAt(var2 + 1), var3);
      }
   }

   public synchronized SListIterator find(Object var1) {
      return (SListIterator)Finding.find(this.start(), this.finish(), var1);
   }

   public synchronized int indexOf(Object var1) {
      SListIterator var2 = (SListIterator)Finding.find(this.start(), this.finish(), var1);
      return var2.myNode == null ? -1 : var2.index();
   }

   public synchronized SListIterator find(SListIterator var1, SListIterator var2, Object var3) {
      return (SListIterator)Finding.find(var1, var2, var3);
   }

   public synchronized int indexOf(int var1, int var2, Object var3) {
      if (var2 < var1) {
         return 0;
      } else {
         this.checkRange(var1, var2);
         SListIterator var4 = this.iteratorAt(var2 + 1);
         SListIterator var5 = (SListIterator)Finding.find(this.iteratorAt(var1), var4, var3);
         return var5.myNode == var4.myNode ? -1 : var5.index();
      }
   }

   public synchronized boolean contains(Object var1) {
      SListIterator var2 = this.find(var1);
      SListIterator var3 = this.end();
      return var2.myNode != var3.myNode && true;
   }

   public synchronized Object remove(Enumeration var1) {
      if (!(var1 instanceof SListIterator)) {
         throw new IllegalArgumentException("Enumeration not a SListIterator");
      } else if (((SListIterator)var1).mySList != this) {
         throw new IllegalArgumentException("Enumeration not for this SList");
      } else {
         SListIterator var2 = (SListIterator)var1;
         Object var3 = var2.myNode.object;
         this.remove(((SListIterator)var1).myNode);
         return var3;
      }
   }

   public synchronized Object remove(int var1) {
      if (var1 >= 0 && var1 < this.myLength) {
         return this.remove(this.nodeAt(var1));
      } else {
         throw new IndexOutOfBoundsException("Attempt to access index " + var1 + " when valid range is 0.." + (this.myLength - 1));
      }
   }

   public synchronized int remove(Enumeration var1, Enumeration var2) {
      if (var1 instanceof SListIterator && var2 instanceof SListIterator) {
         if (((SListIterator)var1).mySList == this && ((SListIterator)var2).mySList == this) {
            SListIterator var3 = (SListIterator)var1;
            SListIterator var4 = (SListIterator)var2;
            return this.remove(var3.myNode, var4.myNode);
         } else {
            throw new IllegalArgumentException("Enumeration not for this SList");
         }
      } else {
         throw new IllegalArgumentException("Enumeration not a SListIterator");
      }
   }

   public synchronized int remove(int var1, int var2) {
      if (var2 < var1) {
         return 0;
      } else {
         this.checkRange(var1, var2);
         return this.remove(this.nodeAt(var1), this.nodeAt(var2 + 1));
      }
   }

   public synchronized void splice(SListIterator var1, SList var2) {
      this.splice(var1.myNode, var2);
   }

   public synchronized void splice(int var1, SList var2) {
      if (var1 > this.myLength) {
         throw new IndexOutOfBoundsException("Attempt to insert at index " + var1 + " when valid range is 0.." + this.myLength);
      } else {
         this.splice(this.nodeAt(var1), var2);
      }
   }

   public synchronized void splice(SListIterator var1, SList var2, SListIterator var3) {
      this.splice(var1.myNode, var2, var3.myNode);
   }

   public synchronized void splice(int var1, SList var2, int var3) {
      if (var1 > this.myLength) {
         throw new IndexOutOfBoundsException("Attempt to insert at index " + var1 + " when valid range is 0.." + this.myLength);
      } else if (var3 >= 0 && var3 < var2.myLength) {
         this.splice(this.nodeAt(var1), var2, var2.nodeAt(var3));
      } else {
         throw new IndexOutOfBoundsException("Attempt to access index " + var3 + " when valid range is 0.." + (var2.myLength - 1));
      }
   }

   public synchronized void splice(SListIterator var1, SList var2, SListIterator var3, SListIterator var4) {
      this.splice(var1.myNode, var2, var3.myNode, var4.myNode);
   }

   public synchronized void splice(int var1, SList var2, int var3, int var4) {
      if (var1 > this.myLength) {
         throw new IndexOutOfBoundsException("Attempt to insert at index " + var1 + " when valid range is 0.." + this.myLength);
      } else if (var3 >= 0 && var3 < var2.myLength) {
         if (var4 >= 0 && var4 < var2.myLength) {
            this.splice(this.nodeAt(var1), var2, var2.nodeAt(var3), var2.nodeAt(var4 + 1));
         } else {
            throw new IndexOutOfBoundsException("Attempt to access index " + var4 + " when valid range is 0.." + (var2.myLength - 1));
         }
      } else {
         throw new IndexOutOfBoundsException("Attempt to access index " + var3 + " when valid range is 0.." + (var2.myLength - 1));
      }
   }

   private Object remove(SListNode var1) {
      SListNode var2 = null;

      for(SListNode var3 = this.myHead; var3 != var1; var3 = var3.next) {
         var2 = var3;
      }

      if (var2 == null) {
         this.myHead = var1.next;
      } else {
         var2.next = var1.next;
      }

      if (var1 == this.myTail) {
         this.myTail = var2;
      }

      --this.myLength;
      return var1.object;
   }

   private int remove(SListNode var1, SListNode var2) {
      SListNode var3 = null;

      for(SListNode var4 = this.myHead; var4 != var1; var4 = var4.next) {
         var3 = var4;
      }

      if (var3 == null) {
         this.myHead = var2;
      } else {
         var3.next = var2;
      }

      if (var2 == null) {
         this.myTail = var3;
      }

      int var5;
      for(var5 = 0; var1 != var2; ++var5) {
         var1 = var1.next;
      }

      this.myLength -= var5;
      return var5;
   }

   private void splice(SListNode var1, SList var2) {
      synchronized(var2){}

      try {
         if (this != var2 && var2.myLength != 0) {
            SListNode var5 = null;

            for(SListNode var6 = this.myHead; var6 != var1; var6 = var6.next) {
               var5 = var6;
            }

            if (var5 == null) {
               this.myHead = var2.myHead;
            } else {
               var5.next = var2.myHead;
            }

            if (var1 == null) {
               this.myTail = var2.myTail;
            } else {
               var2.myTail.next = var1;
            }

            this.myLength += var2.myLength;
            var2.clear();
            return;
         }
      } catch (Throwable var8) {
         throw var8;
      }

   }

   private void splice(SListNode var1, SList var2, SListNode var3) {
      synchronized(var2){}

      try {
         if (var1 != var3 && var1 != var3.next) {
            var2.remove(var3);
            SListNode var6 = null;

            for(SListNode var7 = this.myHead; var7 != var1; var7 = var7.next) {
               var6 = var7;
            }

            if (var6 == null) {
               this.myHead = var3;
            } else {
               var6.next = var3;
            }

            if (var1 == null) {
               this.myTail = var3;
            }

            var3.next = var1;
            ++this.myLength;
            return;
         }
      } catch (Throwable var9) {
         throw var9;
      }

   }

   private void splice(SListNode var1, SList var2, SListNode var3, SListNode var4) {
      if (var3 != var4) {
         synchronized(var2){}

         try {
            if (var2 == this) {
               SListNode var7 = var3;
               if (var1 == var3 || var1 == var4) {
                  return;
               }

               while(var7 != var4) {
                  if (var1 == var7) {
                     throw new InvalidOperationException("Tried to splice into an overlapping area.");
                  }

                  var7 = var7.next;
               }
            }

            var2.remove(var3, var4);
            SListNode var13 = null;

            for(SListNode var8 = this.myHead; var8 != var1; var8 = var8.next) {
               var13 = var8;
            }

            if (var13 == null) {
               this.myHead = var3;
            } else {
               var13.next = var3;
            }

            SListNode var9 = var3;

            int var10;
            for(var10 = 1; var9.next != var4; ++var10) {
               var9 = var9.next;
            }

            if (var1 == null) {
               this.myTail = var9;
            }

            var9.next = var1;
            this.myLength += var10;
         } catch (Throwable var12) {
            throw var12;
         }
      }
   }

   private SListNode insert(SListNode var1, Object var2) {
      SListNode var3 = null;

      for(SListNode var4 = this.myHead; var4 != var1; var4 = var4.next) {
         var3 = var4;
      }

      SListNode var5 = new SListNode(this);
      var5.object = var2;
      if (var3 == null) {
         this.myHead = var5;
      } else {
         var3.next = var5;
      }

      var5.next = var1;
      ++this.myLength;
      return var5;
   }

   private void insert(SListNode var1, int var2, Object var3) {
      SListNode var4 = null;
      SListNode var5 = null;
      this.myLength += var2;

      for(SListNode var6 = this.myHead; var6 != var1; var6 = var6.next) {
         var4 = var6;
      }

      while(true) {
         --var2;
         if (var2 < 0) {
            var5.next = var1;
            return;
         }

         var5 = new SListNode(this);
         var5.object = var3;
         if (var4 == null) {
            this.myHead = var5;
         } else {
            var4.next = var5;
         }

         var4 = var5;
      }
   }

   private int remove(SListNode var1, SListNode var2, Object var3, int var4) {
      if (var4 <= 0) {
         return 0;
      } else {
         int var5 = 0;
         SListNode var6 = null;

         SListNode var7;
         for(var7 = this.myHead; var7 != var1; var7 = var7.next) {
            var6 = var7;
         }

         for(; var4 > 0 && var7 != var2; var7 = var7.next) {
            if (var7.object.equals(var3)) {
               if (var6 == null) {
                  this.myHead = var7.next;
               } else {
                  var6.next = var7.next;
               }

               if (var7 == this.myTail) {
                  this.myTail = var6;
               }

               ++var5;
               --var4;
            } else {
               var6 = var7;
            }
         }

         this.myLength -= var5;
         return var5;
      }
   }

   private SListIterator iteratorAt(int var1) {
      SListNode var2;
      for(var2 = this.myHead; var1-- > 0; var2 = var2.next) {
      }

      return new SListIterator(this, var2);
   }

   private SListNode nodeAt(int var1) {
      SListNode var2;
      for(var2 = this.myHead; var1-- > 0; var2 = var2.next) {
      }

      return var2;
   }

   private void checkRange(int var1, int var2) {
      if (var1 >= 0 && var1 < this.myLength) {
         if (var2 < 0 || var2 >= this.myLength) {
            throw new IndexOutOfBoundsException("Attempt to access index " + var2 + " when valid range is 0.." + (this.myLength - 1));
         }
      } else {
         throw new IndexOutOfBoundsException("Attempt to access index " + var1 + " when valid range is 0.." + (this.myLength - 1));
      }
   }
}
