package COM.objectspace.jgl;

import java.io.Serializable;

public final class SListIterator implements ForwardIterator, Serializable {
   SList mySList;
   SList.SListNode myNode;

   public SListIterator() {
   }

   SListIterator(SList var1, SList.SListNode var2) {
      this.mySList = var1;
      this.myNode = var2;
   }

   public SListIterator(SListIterator var1) {
      this.mySList = var1.mySList;
      this.myNode = var1.myNode;
   }

   public Object clone() {
      return new SListIterator(this);
   }

   public boolean equals(Object var1) {
      if (var1 instanceof SListIterator) {
         SListIterator var2 = (SListIterator)var1;
         if (this.myNode == var2.myNode || false) {
            return true;
         }
      }

      return false;
   }

   public boolean equals(SListIterator var1) {
      return this.myNode == var1.myNode;
   }

   public boolean atBegin() {
      return this.myNode == this.mySList.myHead;
   }

   public boolean atEnd() {
      return this.myNode == null;
   }

   public boolean hasMoreElements() {
      return this.myNode != null;
   }

   public void advance() {
      this.myNode = this.myNode.next;
   }

   public void advance(int var1) {
      if (var1 < 0) {
         throw new InvalidOperationException("Attempt to advance a ForwardIterator in the wrong direction.");
      } else {
         while(var1-- > 0) {
            this.myNode = this.myNode.next;
         }

      }
   }

   public Object nextElement() {
      Object var1 = this.myNode.object;
      this.myNode = this.myNode.next;
      return var1;
   }

   public Object get() {
      return this.myNode.object;
   }

   public void put(Object var1) {
      this.myNode.object = var1;
   }

   public int distance(ForwardIterator var1) {
      return this.distance(this.myNode, ((SListIterator)var1).myNode);
   }

   public int index() {
      return this.distance(this.mySList.myHead, this.myNode);
   }

   private int distance(SList.SListNode var1, SList.SListNode var2) {
      int var3;
      for(var3 = 0; var1 != var2; var1 = var1.next) {
         ++var3;
      }

      return var3;
   }

   public Container getContainer() {
      return this.mySList;
   }
}
