package COM.objectspace.jgl;

import java.io.Serializable;

public final class ShortIterator implements RandomAccessIterator, Serializable {
   ShortArray myShortArray;
   short[] myArray;
   int myIndex;

   public static ShortIterator begin(short[] var0) {
      return new ShortIterator(var0, 0, new ShortArray(var0));
   }

   public static ShortIterator begin(short[] var0, ShortArray var1) {
      return new ShortIterator(var0, 0, var1);
   }

   public static ShortIterator end(short[] var0) {
      return new ShortIterator(var0, var0.length, new ShortArray(var0));
   }

   public static ShortIterator end(short[] var0, ShortArray var1) {
      return new ShortIterator(var0, var0.length, var1);
   }

   public ShortIterator() {
   }

   public ShortIterator(ShortIterator var1) {
      this.myShortArray = var1.myShortArray;
      this.myArray = var1.myArray;
      this.myIndex = var1.myIndex;
   }

   public ShortIterator(short[] var1) {
      this(var1, 0, new ShortArray(var1));
   }

   public ShortIterator(short[] var1, ShortArray var2) {
      this(var1, 0, var2);
   }

   public ShortIterator(short[] var1, int var2) {
      this(var1, var2, new ShortArray(var1));
   }

   public ShortIterator(short[] var1, int var2, ShortArray var3) {
      this.myShortArray = var3;
      this.myArray = var1;
      this.myIndex = var2;
   }

   public Object clone() {
      return new ShortIterator(this);
   }

   public int index() {
      return this.myIndex;
   }

   public boolean equals(Object var1) {
      if (var1 instanceof ShortIterator) {
         ShortIterator var2 = (ShortIterator)var1;
         if (var2.myIndex == this.myIndex && (var2.myArray == this.myArray || false)) {
            return true;
         }
      }

      return false;
   }

   public boolean equals(ShortIterator var1) {
      return var1.myIndex == this.myIndex && var1.myArray == this.myArray;
   }

   public boolean less(RandomAccessIterator var1) {
      return this.myIndex < ((ShortIterator)var1).myIndex;
   }

   public Object get(int var1) {
      return new Integer(this.myArray[this.myIndex + var1]);
   }

   public void put(int var1, Object var2) {
      this.myArray[this.myIndex + var1] = (short)(Integer)var2;
   }

   public boolean atBegin() {
      return this.myIndex == 0;
   }

   public boolean atEnd() {
      return this.myIndex == this.myArray.length;
   }

   public boolean hasMoreElements() {
      return this.myIndex < this.myArray.length;
   }

   public void advance() {
      ++this.myIndex;
   }

   public void advance(int var1) {
      this.myIndex += var1;
   }

   public void retreat() {
      --this.myIndex;
   }

   public void retreat(int var1) {
      this.myIndex -= var1;
   }

   public Object nextElement() {
      return new Integer(this.myArray[this.myIndex++]);
   }

   public Object get() {
      return new Integer(this.myArray[this.myIndex]);
   }

   public void put(Object var1) {
      this.myArray[this.myIndex] = (short)(Integer)var1;
   }

   public int distance(ForwardIterator var1) {
      return ((ShortIterator)var1).myIndex - this.myIndex;
   }

   public Container getContainer() {
      return this.myShortArray;
   }
}
