package COM.objectspace.jgl;

import java.util.Random;

public final class Shuffling {
   static Random rand = new Random();

   private Shuffling() {
   }

   public static void randomShuffle(BidirectionalIterator var0, BidirectionalIterator var1) {
      if (!(var0.getContainer() instanceof Sequence)) {
         throw new IllegalArgumentException("iterator containers must be a Sequence");
      } else if (!var0.equals(var1)) {
         BidirectionalIterator var2 = (BidirectionalIterator)var0.clone();
         var2.advance();

         for(int var3 = 2; !var2.equals(var1); ++var3) {
            BidirectionalIterator var4 = (BidirectionalIterator)var0.clone();
            var4.advance(Math.abs(rand.nextInt()) % var3);
            Swapping.iterSwap(var2, var4);
            var2.advance();
         }

      }
   }

   public static void randomShuffle(Container var0) {
      randomShuffle((BidirectionalIterator)var0.start(), (BidirectionalIterator)var0.finish());
   }
}
