package COM.objectspace.jgl;

import java.util.Enumeration;

public class Stack implements Container {
   Sequence mySequence;

   public Stack() {
      this.mySequence = new Array();
   }

   public Stack(Sequence var1) {
      synchronized(var1){}

      try {
         this.mySequence = (Sequence)var1.clone();
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public Stack(Stack var1) {
      synchronized(var1){}

      try {
         this.mySequence = (Sequence)var1.mySequence.clone();
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public synchronized void copy(Stack var1) {
      synchronized(var1){}

      try {
         if (this != var1) {
            this.mySequence = (Sequence)var1.mySequence.clone();
         }
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public synchronized Object clone() {
      return new Stack((Sequence)this.mySequence.clone());
   }

   public synchronized String toString() {
      return "Stack( " + this.mySequence.toString() + " )";
   }

   public boolean equals(Object var1) {
      return var1 instanceof Stack && this.equals((Stack)var1);
   }

   public synchronized boolean equals(Stack var1) {
      return this.mySequence.equals(var1.mySequence);
   }

   public synchronized int hashCode() {
      return this.mySequence.hashCode();
   }

   public boolean isEmpty() {
      return this.mySequence.isEmpty();
   }

   public int size() {
      return this.mySequence.size();
   }

   public int maxSize() {
      return this.mySequence.maxSize();
   }

   public synchronized Object top() {
      return this.mySequence.back();
   }

   public synchronized Object add(Object var1) {
      this.mySequence.pushBack(var1);
      return null;
   }

   public void push(Object var1) {
      this.add(var1);
   }

   public synchronized Object pop() {
      return this.mySequence.popBack();
   }

   public synchronized void clear() {
      this.mySequence.clear();
   }

   public synchronized Enumeration elements() {
      return this.mySequence.elements();
   }

   public synchronized ForwardIterator start() {
      return this.mySequence.start();
   }

   public synchronized ForwardIterator finish() {
      return this.mySequence.finish();
   }

   public synchronized void swap(Stack var1) {
      synchronized(var1){}

      try {
         Sequence var4 = this.mySequence;
         this.mySequence = var1.mySequence;
         var1.mySequence = var4;
      } catch (Throwable var6) {
         throw var6;
      }

   }

   public Object remove(Enumeration var1) {
      throw new InvalidOperationException("cannot execute remove() on a stack");
   }

   public int remove(Enumeration var1, Enumeration var2) {
      throw new InvalidOperationException("cannot execute remove() on a stack");
   }
}
