package COM.objectspace.jgl;

public final class Swapping {
   private Swapping() {
   }

   public static void iterSwap(ForwardIterator var0, ForwardIterator var1) {
      Object var2 = var0.get();
      var0.put(var1.get());
      var1.put(var2);
   }

   public static ForwardIterator swapRanges(ForwardIterator var0, ForwardIterator var1, ForwardIterator var2) {
      ForwardIterator var3 = (ForwardIterator)var0.clone();
      ForwardIterator var4 = (ForwardIterator)var2.clone();

      while(!var3.equals(var1)) {
         iterSwap(var3, var4);
         var3.advance();
         var4.advance();
      }

      return var4;
   }

   public static ForwardIterator swapRanges(Container var0, Container var1) {
      return swapRanges(var0.start(), var0.finish(), var1.start());
   }
}
