package COM.objectspace.jgl;

public final class Transforming {
   private Transforming() {
   }

   public static OutputIterator transform(InputIterator var0, InputIterator var1, OutputIterator var2, UnaryFunction var3) {
      InputIterator var4 = (InputIterator)var0.clone();
      OutputIterator var5 = (OutputIterator)var2.clone();

      while(!var4.equals(var1)) {
         var5.put(var3.execute(var4.nextElement()));
         var5.advance();
      }

      return var5;
   }

   public static OutputIterator transform(Container var0, OutputIterator var1, UnaryFunction var2) {
      return transform((InputIterator)var0.start(), (InputIterator)var0.finish(), (OutputIterator)var1, (UnaryFunction)var2);
   }

   public static void transform(Container var0, Container var1, UnaryFunction var2) {
      transform((InputIterator)var0.start(), (InputIterator)var0.finish(), (OutputIterator)(new InsertIterator(var1)), (UnaryFunction)var2);
   }

   public static OutputIterator transform(InputIterator var0, InputIterator var1, InputIterator var2, OutputIterator var3, BinaryFunction var4) {
      InputIterator var5 = (InputIterator)var0.clone();
      InputIterator var6 = (InputIterator)var2.clone();
      OutputIterator var7 = (OutputIterator)var3.clone();

      while(!var5.equals(var1)) {
         var7.put(var4.execute(var5.nextElement(), var6.nextElement()));
         var7.advance();
      }

      return var7;
   }

   public static OutputIterator transform(Container var0, Container var1, OutputIterator var2, BinaryFunction var3) {
      return transform(var0.start(), var0.finish(), var1.start(), var2, var3);
   }

   public static void transform(Container var0, Container var1, Container var2, BinaryFunction var3) {
      transform(var0.start(), var0.finish(), var1.start(), new InsertIterator(var2), var3);
   }

   public static Container collect(ForwardIterator var0, ForwardIterator var1, UnaryFunction var2) {
      Class var3 = var0.getContainer().getClass();
      Class var4 = var1.getContainer().getClass();
      if (var3 != var4) {
         throw new IllegalArgumentException("iterator containers must be the same");
      } else {
         return collect(var0, var1, var2, (Container)var0.getContainer().clone());
      }
   }

   public static Container collect(Container var0, UnaryFunction var1) {
      return collect(var0.start(), var0.finish(), var1, (Container)var0.clone());
   }

   private static Container collect(ForwardIterator var0, ForwardIterator var1, UnaryFunction var2, Container var3) {
      var3.clear();
      ForwardIterator var4 = (ForwardIterator)var0.clone();

      while(!var4.equals(var1)) {
         var3.add(var2.execute(var4.nextElement()));
      }

      return var3;
   }
}
