package COM.objectspace.jgl;

import java.util.Enumeration;
import java.util.Vector;

public class VectorArray extends ArrayAdapter {
   Vector myVector;

   public VectorArray() {
      this.myVector = new Vector();
   }

   public VectorArray(Vector var1) {
      synchronized(var1){}

      try {
         this.myVector = var1;
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public VectorArray(VectorArray var1) {
      synchronized(var1){}

      try {
         this.myVector = var1.myVector;
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public synchronized Object clone() {
      return new VectorArray(this);
   }

   public synchronized String toString() {
      return this.myVector.toString();
   }

   public boolean equals(Object var1) {
      return this.myVector.equals(((VectorArray)var1).myVector);
   }

   public int size() {
      return this.myVector.size();
   }

   public int maxSize() {
      return Integer.MAX_VALUE;
   }

   public synchronized Enumeration elements() {
      Vector var1 = this.myVector;
      return new VectorIterator(var1, 0, this);
   }

   public synchronized ForwardIterator start() {
      Vector var1 = this.myVector;
      return new VectorIterator(var1, 0, this);
   }

   public synchronized ForwardIterator finish() {
      Vector var1 = this.myVector;
      return new VectorIterator(var1, var1.size(), this);
   }

   // $FF: renamed from: at (int) java.lang.Object
   public synchronized Object method_0(int var1) {
      return this.myVector.elementAt(var1);
   }

   public synchronized void put(int var1, Object var2) {
      this.myVector.setElementAt(var2, var1);
   }

   public void clear() {
      this.myVector.removeAllElements();
   }

   public synchronized Object add(Object var1) {
      this.myVector.addElement(var1);
      return null;
   }

   public synchronized void pushFront(Object var1) {
      this.myVector.insertElementAt(var1, 0);
   }

   public synchronized Object popFront() {
      Object var1 = this.myVector.firstElement();
      this.myVector.removeElementAt(0);
      return var1;
   }

   public void pushBack(Object var1) {
      this.add(var1);
   }

   public synchronized Object popBack() {
      Object var1 = this.myVector.lastElement();
      this.myVector.removeElementAt(this.myVector.size() - 1);
      return var1;
   }

   public synchronized int remove(Object var1) {
      int var2;
      for(var2 = 0; this.myVector.removeElement(var1); ++var2) {
      }

      return var2;
   }

   public synchronized int remove(Object var1, int var2) {
      int var3;
      for(var3 = 0; var2 > 0 && this.myVector.removeElement(var1); --var2) {
         ++var3;
      }

      return var3;
   }

   public synchronized int remove(int var1, int var2, Object var3) {
      if (var1 >= 0 && var2 <= this.myVector.size() - 1) {
         int var4 = 0;
         int var5 = var1;

         for(int var6 = var1; var6 < var2; ++var6) {
            if (this.myVector.elementAt(var5).equals(var3)) {
               this.myVector.removeElementAt(var5);
               ++var4;
            } else {
               ++var5;
            }
         }

         return var4;
      } else {
         throw new IndexOutOfBoundsException("index out of range for this Vector.");
      }
   }
}
