package COM.objectspace.jgl;

import java.io.Serializable;
import java.util.Vector;

public final class VectorIterator implements RandomAccessIterator, Serializable {
   VectorArray myVectorArray;
   Vector myVector;
   int myIndex;

   public static VectorIterator begin(Vector var0) {
      return new VectorIterator(var0, 0, new VectorArray(var0));
   }

   public static VectorIterator begin(Vector var0, VectorArray var1) {
      return new VectorIterator(var0, 0, var1);
   }

   public static VectorIterator end(Vector var0) {
      return new VectorIterator(var0, var0.size(), new VectorArray(var0));
   }

   public static VectorIterator end(Vector var0, VectorArray var1) {
      return new VectorIterator(var0, var0.size(), var1);
   }

   public VectorIterator() {
   }

   public VectorIterator(VectorIterator var1) {
      this.myVectorArray = var1.myVectorArray;
      this.myVector = var1.myVector;
      this.myIndex = var1.myIndex;
   }

   public VectorIterator(Vector var1, int var2) {
      this(var1, var2, new VectorArray(var1));
   }

   public VectorIterator(Vector var1, int var2, VectorArray var3) {
      this.myVectorArray = var3;
      this.myVector = var1;
      this.myIndex = var2;
   }

   public Object clone() {
      return new VectorIterator(this);
   }

   public boolean equals(Object var1) {
      if (var1 instanceof VectorIterator) {
         VectorIterator var2 = (VectorIterator)var1;
         if (var2.myIndex == this.myIndex && (var2.myVector == this.myVector || false)) {
            return true;
         }
      }

      return false;
   }

   public boolean equals(VectorIterator var1) {
      return var1.myIndex == this.myIndex && var1.myVector == this.myVector;
   }

   public boolean less(RandomAccessIterator var1) {
      return this.myIndex < ((VectorIterator)var1).myIndex;
   }

   public Object get(int var1) {
      return this.myVector.elementAt(this.myIndex + var1);
   }

   public void put(int var1, Object var2) {
      this.myVector.setElementAt(var2, this.myIndex + var1);
   }

   public boolean atBegin() {
      return this.myIndex == 0;
   }

   public boolean atEnd() {
      return this.myIndex == this.myVector.size();
   }

   public boolean hasMoreElements() {
      return this.myIndex < this.myVector.size();
   }

   public void advance() {
      ++this.myIndex;
   }

   public void advance(int var1) {
      this.myIndex += var1;
   }

   public void retreat() {
      --this.myIndex;
   }

   public void retreat(int var1) {
      this.myIndex -= var1;
   }

   public Object nextElement() {
      return this.myVector.elementAt(this.myIndex++);
   }

   public Object get() {
      return this.myVector.elementAt(this.myIndex);
   }

   public void put(Object var1) {
      this.myVector.setElementAt(var1, this.myIndex);
   }

   public int distance(ForwardIterator var1) {
      return ((VectorIterator)var1).myIndex - this.myIndex;
   }

   public int index() {
      return this.myIndex;
   }

   public Container getContainer() {
      return this.myVectorArray;
   }
}
